CREATE GLOBAL TEMPORARY TABLE TMP_TURCAIXA
(CDFILIAL     VARCHAR2(4)  NOT NULL,
 CDCAIXA      VARCHAR2(3)  NOT NULL,
 DTABERCAIX   DATE         NOT NULL,
 DTFECHCAIX   DATE,
 DTMOVTURCAIX DATE,
 NRECFTURCAIX VARCHAR2(4),
 CDOPERADOR   VARCHAR2(12) NOT NULL,
 STATUS       VARCHAR2(1)) ON COMMIT PRESERVE ROWS
/
CREATE GLOBAL TEMPORARY TABLE TMP_VENDA
(CDFILIAL 	 VARCHAR2(4)    NOT NULL,
 CDCAIXA  	 VARCHAR2(3)    NOT NULL,
 NRSEQVENDA 	 VARCHAR2(10)   NOT NULL,
 CDCLIENTE 	 VARCHAR2(25)   NOT NULL,
 CDCONSUMIDOR 	 VARCHAR2(25),
 DTVENDA 	 DATE           NOT NULL,
 DTENTRVENDA 	 DATE           NOT NULL,
 DTABERTUR 	 DATE           NOT NULL,
 NRCUPOMFIS 	 VARCHAR2(10),
 NRCONTCUPOMFISC VARCHAR(10),
 NRSERIEIMPVND 	 VARCHAR2(50),
 CDFILIALTUR 	 VARCHAR2(4)    NOT NULL,
 CDCAIXATUR 	 VARCHAR2(3)    NOT NULL,
 NRINSCRCONS 	 VARCHAR2(20),
 DSREFENDCONSVEN VARCHAR2(2000),
 STATUS          VARCHAR2(1)) ON COMMIT PRESERVE ROWS
/
CREATE GLOBAL TEMPORARY TABLE TMP_ITEMVENDA
(CDFILIAL      VARCHAR2(4)  NOT NULL,
 CDCAIXA       VARCHAR2(3)  NOT NULL,
 NRSEQVENDA    VARCHAR2(10) NOT NULL,
 NRSEQUITVEND  VARCHAR2(10) NOT NULL,
 QTPRODVEND    FLOAT(126)   NOT NULL,
 VRUNITVEND    FLOAT(126)   NOT NULL,
 VRUNITVENDCL  FLOAT(126),
 VRDESITVEND   FLOAT(126),
 CDPRODUTO     VARCHAR2(10) NOT NULL,
 CDORDALIQIMPR VARCHAR2(5),
 VRALIQIMPR    FLOAT(126),
 NRORDITCUPFIS VARCHAR2(5),
 VRACRITVEND   FLOAT(126),
 STATUS        VARCHAR2(1)) ON COMMIT PRESERVE ROWS
/
CREATE GLOBAL TEMPORARY TABLE TMP_ITVENDACAN
(CDFILIAL        VARCHAR2(4)  NOT NULL,
 CDCAIXA         VARCHAR2(3)  NOT NULL,
 NRSEQVENDA      VARCHAR2(10) NOT NULL,
 NRSEQUITVENDC   VARCHAR2(10) NOT NULL,
 QTPRODVENDC     FLOAT(126)   NOT NULL,
 VRUNITVENDC     FLOAT(126)   NOT NULL,
 VRDESITVENDC    FLOAT(126),
 VRPERCVENDC     FLOAT(126),
 CDPRODUTO       VARCHAR2(10) NOT NULL,
 VRUNITVENCLC    FLOAT(126)   NOT NULL,
 CDORDALIQIMPR   VARCHAR2(5),
 VRALIQIMPR      FLOAT(126),
 NRORDITCUPFISCA VARCHAR2(5),
 VRACRITVENDC    FLOAT(126),
 STATUS          VARCHAR2(1)) ON COMMIT PRESERVE ROWS
/
CREATE GLOBAL TEMPORARY TABLE TMP_ITVENDAIMPOS
(CDFILIAL    VARCHAR2(4)  NOT NULL,
CDCAIXA      VARCHAR2(3)  NOT NULL,
NRSEQVENDA   VARCHAR(10)  NOT NULL,
NRSEQUITVEND VARCHAR2(10) NOT NULL,
NRSEQITIMPOS VARCHAR2(10) NOT NULL,
CDIMPOSTO    VARCHAR2(2),
VRPEALPRODIT FLOAT(126),
VRIMPOPRODIT FLOAT(126),
STATUS       VARCHAR2(2)) ON COMMIT PRESERVE ROWS
/
CREATE GLOBAL TEMPORARY TABLE TMP_MOVCAIXA
(CDFILIAL    VARCHAR2(4)  NOT NULL,
CDCAIXA      VARCHAR2(3)  NOT NULL,
DTABERCAIX   DATE         NOT NULL,
NRSEQUMOVI   VARCHAR2(10) NOT NULL,
IDTIPOMOVIVE VARCHAR2(1)  NOT NULL,
VRMOVIVEND   FLOAT(126)   NOT NULL,
NRSEQVENDA   VARCHAR(10),
CDTIPORECE   VARCHAR2(3),
DTHRINCMOV   DATE,
DTMOVIMCAIXA DATE,
CDCLIENTE    VARCHAR2(25),
NRCARTBANCO  VARCHAR2(10),
CDNSUHOSTTEF VARCHAR2(50),
DSMOVIVEND   VARCHAR2(250),
STATUS       VARCHAR2(1)) ON COMMIT PRESERVE ROWS
/
CREATE GLOBAL TEMPORARY TABLE TMP_REDUCAOZ 
(CDFILIAL     VARCHAR2(4)   NOT NULL,
CDCAIXA       VARCHAR2(3)   NOT NULL, 
NRECFREDZ     VARCHAR2(10)  NOT NULL, 
DTREDUCAOZ    DATE,
NRREINIREDZ   VARCHAR2(10)  NOT NULL,
NRREDREDZ     VARCHAR2(10), 
VRGTREDZ      FLOAT(126), 
VRVENBRUREDZ  FLOAT(126),
VRISSREDZ     FLOAT(126), 
VRTOTCANREDZ  FLOAT(126), 
VRTOTDESREDZ  FLOAT(126), 
VRVENLIQREDZ  FLOAT(126), 
VRTOTACRREDZ  FLOAT(126), 
VRSTRIBREDZ   FLOAT(126), 
VRISENCREDZ   FLOAT(126), 
VRNINCIDREDZ  FLOAT(126)    NOT NULL, 
NRSERIEREDZ   VARCHAR2(30), 
DSMODMARCAECF VARCHAR2(30)  NOT NULL, 
NRUSUARIOMFD  VARCHAR2(10), 
CDMFADICIONAL VARCHAR2(5), 
DTEMISREDZ    DATE, 
NRPRIMCFREDZ  VARCHAR2(10), 
NRULTCFREDZ   VARCHAR2(10), 
NRCANCFREDZ   VARCHAR2(10), 
STATUS        VARCHAR2(1)) ON COMMIT PRESERVE ROWS ;
/
CREATE GLOBAL TEMPORARY TABLE TMP_IMPOSTOREDZ 
(CDFILIAL       VARCHAR2(4)  NOT NULL, 
 CDCAIXA        VARCHAR2(3)  NOT NULL, 
 NRECFREDZ      VARCHAR2(10) NOT NULL, 
 DTREDUCAOZ     DATE         NOT NULL, 
 CDIMPOSTO      VARCHAR2(2)  NOT NULL, 
 VRALIQIMPRZ    FLOAT(126)   NOT NULL, 
 VRBCALCIMPRZ   FLOAT(126), 
 VRIMPOSTORZ    FLOAT(126), 
 NRSEQALIQIMPRZ VARCHAR2(5), 
 STATUS         VARCHAR2(1)) ON COMMIT PRESERVE ROWS
/
CREATE GLOBAL TEMPORARY TABLE TMP_FORMPGTOREDZ
(CDFILIAL     VARCHAR2(4)   NOT NULL,
 CDCAIXA      VARCHAR2(3)   NOT NULL,
 NRECFREDZ    VARCHAR2(10), 
 DTREDUCAOZ   DATE          NOT NULL,
 CDTIPORECE   VARCHAR2(3)   NOT NULL,
 VRFORMPGTORZ FLOAT(126),
 STATUS       VARCHAR2(1)) ON COMMIT PRESERVE ROWS
/
CREATE TABLE ERROIMPORTVENDA 
(CDFILIAL    VARCHAR2(4),
CDCAIXA      VARCHAR2(3),
NRSEQVENDA   VARCHAR2(10),
NRSEQUITVEND VARCHAR2(10),
CDCLIENTE    VARCHAR2(25),
CDPRODUTO    VARCHAR2(15),
CDTIPORECE   VARCHAR2(10),
DTABERCAIX   DATE,
DTABERTUR    DATE, 
DTVENDA      DATE,
DTREDUCAOZ   DATE,
DESCRICAO    VARCHAR2(500))
/
create or replace
PROCEDURE VD_IMPORTACAO_VENDA(P_RETORNO OUT VARCHAR,
                              P_VALIDO  VARCHAR2,
                              P_EMPRESA VARCHAR2) AS
   V_CONTAERRO       NUMBER;
   V_CONTCUPOMFISC   NUMBER;
   V_VRTOTVENDA      FLOAT;
   V_VRVENBRUREDZ    FLOAT;
   V_VRVENLIQREDZ    FLOAT;
   V_VRTOTIMPOSTO    FLOAT;
   V_VRTOTVENDACAN   FLOAT;
   V_VRSAIDAMOV      FLOAT;
   V_VRENTRADAMOV    FLOAT;
   V_VRSTRIB         FLOAT;
   V_VRSTRIBREDZ     FLOAT;
   V_VRTRIBUTADO     FLOAT;
   V_VRTRIBUTADOREDZ FLOAT;
   V_VRISENTO        FLOAT;
   V_VRISENTOREDZ    FLOAT;
   V_VRNINCID        FLOAT;
   V_VRNINCIDREDZ    FLOAT;
   V_VRISS           FLOAT;
   V_VRISSREDZ       FLOAT;
   V_NRPRIMCFREDZ    VARCHAR2(10);
   V_NRULTCFREDZ     VARCHAR2(10);
   V_CDFILIAL        VARCHAR2(4);
   V_CDCAIXA         VARCHAR2(3);
   V_CDCLIENTE       VARCHAR2(50);
   V_CDLOJA          VARCHAR2(10);
   V_CDPRODUTO       VARCHAR2(10);
   V_CDIMPOSTO       VARCHAR2(2);
   V_IMPORTA         VARCHAR2(3);
   V_RELAC           VARCHAR2(3);
   V_CDTIPORECE      VARCHAR2(10);
   V_EXISTE          VARCHAR2(1);

BEGIN

  DELETE FROM ERROIMPORTVENDA;

  V_EXISTE := 'N';

  UPDATE TMP_TURCAIXA
     SET STATUS = 'N';

  IF (P_VALIDO = 'N') THEN /*Verifica se a estrutura do arquivo est valida ou no*/

  /*INICIO - VALIDAO DA ESTRUTURA DO ARQUIVO IMPORTADO*/

      /*Valida se existe abertura de caixa sem venda*/
      FOR TMP_TURCAIXA IN (SELECT * FROM TMP_TURCAIXA) LOOP
         FOR TMP_VENDA IN (SELECT * FROM TMP_VENDA) LOOP
            UPDATE TMP_TURCAIXA
               SET STATUS = 'S'
             WHERE TMP_TURCAIXA.CDFILIAL   = TMP_VENDA.CDFILIALTUR AND
                   TMP_TURCAIXA.CDCAIXA    = TMP_VENDA.CDCAIXATUR  AND
                   TMP_TURCAIXA.DTABERCAIX = TMP_VENDA.DTABERTUR;
         END LOOP;
      END LOOP;

      FOR TMP_TURCAIXA IN (SELECT * FROM TMP_TURCAIXA WHERE STATUS = 'N') LOOP
         INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTABERCAIX,DESCRICAO) VALUES (TMP_TURCAIXA.CDFILIAL,TMP_TURCAIXA.CDCAIXA,TMP_TURCAIXA.DTABERCAIX,'ABERTURA DE CAIXA SEM VENDA');
      END LOOP;
      /*Fim*/

      UPDATE TMP_TURCAIXA
         SET STATUS = 'N';

      /*Valida se existe venda sem abertura de caixa correspondente*/
      FOR TMP_VENDA IN (SELECT * FROM TMP_VENDA) LOOP
         FOR TMP_TURCAIXA IN (SELECT * FROM TMP_TURCAIXA) LOOP
            UPDATE TMP_VENDA
               SET STATUS = 'S'
             WHERE TMP_TURCAIXA.CDFILIAL   = TMP_VENDA.CDFILIALTUR AND
                   TMP_TURCAIXA.CDCAIXA    = TMP_VENDA.CDCAIXATUR  AND
                   TMP_TURCAIXA.DTABERCAIX = TMP_VENDA.DTABERTUR;
         END LOOP;
      END LOOP;

      FOR TMP_VENDA IN(SELECT * FROM TMP_VENDA WHERE STATUS = 'N') LOOP
         INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,NRSEQVENDA,DTVENDA,DESCRICAO) VALUES (TMP_VENDA.CDFILIAL,TMP_VENDA.CDCAIXA,TMP_VENDA.NRSEQVENDA,TMP_VENDA.DTVENDA,'VENDA SEM ABERTURA DE CAIXA CORRESPONDENTE');
      END LOOP;
      /*Fim*/

      UPDATE TMP_VENDA
         SET STATUS = 'N';

      /*Valida se existe venda sem movimento(MOVCAIXA)*
      FOR TMP_VENDA IN (SELECT * FROM TMP_VENDA) LOOP
         FOR TMP_MOVCAIXA IN (SELECT * FROM TMP_MOVCAIXA) LOOP
            UPDATE TMP_VENDA
               SET STATUS = 'S'
             WHERE TMP_VENDA.CDFILIAL   = TMP_MOVCAIXA.CDFILIAL    AND
                   TMP_VENDA.CDCAIXA    = TMP_MOVCAIXA.CDCAIXA     AND
                   TMP_VENDA.DTABERTUR  = TMP_MOVCAIXA.DTABERCAIX  AND
                   TMP_VENDA.NRSEQVENDA = TMP_MOVCAIXA.NRSEQVENDA;
         END LOOP;
      END LOOP;

      FOR TMP_VENDA IN (SELECT * FROM TMP_VENDA WHERE STATUS = 'N') LOOP
         INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,NRSEQVENDA,DTVENDA,DESCRICAO) VALUES (TMP_VENDA.CDFILIAL,TMP_VENDA.CDCAIXA,TMP_VENDA.NRSEQVENDA,TMP_VENDA.DTVENDA,'VENDA SEM MOVIMENTO DE CAIXA');
      END LOOP;
      /*Fim*

      UPDATE TMP_MOVCAIXA
         SET STATUS = 'N';

      /*Valida se existe movimento(MOVCAIXA) sem abertura de caixa correspondente*
      FOR TMP_MOVCAIXA IN (SELECT * FROM TMP_MOVCAIXA) LOOP
         FOR TMP_VENDA IN (SELECT * FROM TMP_VENDA) LOOP
            UPDATE TMP_MOVCAIXA
               SET STATUS = 'S'
             WHERE TMP_VENDA.CDFILIAL     = TMP_MOVCAIXA.CDFILIAL     AND
                   TMP_VENDA.CDCAIXA      = TMP_MOVCAIXA.CDCAIXA      AND
                   TMP_VENDA.DTABERTUR    = TMP_MOVCAIXA.DTABERCAIX   AND
                   ((TMP_VENDA.NRSEQVENDA = TMP_MOVCAIXA.NRSEQVENDA) OR ((TMP_MOVCAIXA.NRSEQVENDA IS NULL) AND (TMP_MOVCAIXA.IDTIPOMOVIVE = 'G')));
         END LOOP;
      END LOOP;

      FOR TMP_MOVCAIXA IN (SELECT * FROM TMP_MOVCAIXA WHERE STATUS = 'N') LOOP
         INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTABERCAIX,DESCRICAO) VALUES (TMP_MOVCAIXA.CDFILIAL,TMP_MOVCAIXA.CDCAIXA,TMP_MOVCAIXA.DTABERCAIX,'MOVIMENTO DE CAIXA SEM VENDA CORRESPONDENTE');
      END LOOP;
      /*Fim*/

      UPDATE TMP_VENDA
         SET STATUS = 'N';

      /*Valida se existe venda sem item ou item cancelado*/
      FOR TMP_VENDA IN (SELECT * FROM TMP_VENDA) LOOP
         FOR TMP_ITEMVENDA IN (SELECT * FROM TMP_ITEMVENDA) LOOP
            UPDATE TMP_VENDA
               SET STATUS = 'S'
             WHERE TMP_ITEMVENDA.CDFILIAL   = TMP_VENDA.CDFILIAL    AND
                   TMP_ITEMVENDA.CDCAIXA    = TMP_VENDA.CDCAIXA     AND
                   TMP_ITEMVENDA.NRSEQVENDA = TMP_VENDA.NRSEQVENDA;
         END LOOP;

         FOR TMP_ITVENDACAN IN (SELECT * FROM TMP_ITVENDACAN) LOOP
            UPDATE TMP_VENDA
               SET STATUS = 'S'
             WHERE TMP_ITVENDACAN.CDFILIAL   = TMP_VENDA.CDFILIAL    AND
                   TMP_ITVENDACAN.CDCAIXA    = TMP_VENDA.CDCAIXA     AND
                   TMP_ITVENDACAN.NRSEQVENDA = TMP_VENDA.NRSEQVENDA;
         END LOOP;
      END LOOP;

      FOR TMP_VENDA IN(SELECT * FROM TMP_VENDA WHERE STATUS = 'N') LOOP
         INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,NRSEQVENDA,DTVENDA,DESCRICAO) VALUES (TMP_VENDA.CDFILIAL,TMP_VENDA.CDCAIXA,TMP_VENDA.NRSEQVENDA,TMP_VENDA.DTVENDA,'VENDA SEM ITEM');
      END LOOP;
      /*Fim*/

      UPDATE TMP_ITEMVENDA
         SET STATUS = 'N';

      /*Valida de existe item sem venda correspondente*/
      FOR TMP_ITEMVENDA IN (SELECT * FROM TMP_ITEMVENDA) LOOP
         FOR TMP_VENDA IN (SELECT * FROM TMP_VENDA) LOOP
            UPDATE TMP_ITEMVENDA
               SET STATUS = 'S'
             WHERE TMP_ITEMVENDA.CDFILIAL   = TMP_VENDA.CDFILIAL    AND
                   TMP_ITEMVENDA.CDCAIXA    = TMP_VENDA.CDCAIXA     AND
                   TMP_ITEMVENDA.NRSEQVENDA = TMP_VENDA.NRSEQVENDA;
         END LOOP;
      END LOOP;

      FOR TMP_ITEMVENDA IN(SELECT * FROM TMP_ITEMVENDA WHERE STATUS = 'N') LOOP
         INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,NRSEQVENDA,NRSEQUITVEND,DESCRICAO) VALUES (TMP_ITEMVENDA.CDFILIAL,TMP_ITEMVENDA.CDCAIXA,TMP_ITEMVENDA.NRSEQVENDA,TMP_ITEMVENDA.NRSEQUITVEND,'ITEM SEM VENDA CORRESPONDENTE');
      END LOOP;
      /*Fim*/

      UPDATE TMP_ITVENDACAN
         SET STATUS = 'N';

      /*Valida se existe item cancelado sem venda correspondente*/
      FOR TMP_ITVENDACAN IN (SELECT * FROM TMP_ITVENDACAN) LOOP
         FOR TMP_VENDA IN (SELECT * FROM TMP_VENDA) LOOP
            UPDATE TMP_ITVENDACAN
               SET STATUS = 'S'
             WHERE TMP_ITVENDACAN.CDFILIAL   = TMP_VENDA.CDFILIAL    AND
                   TMP_ITVENDACAN.CDCAIXA    = TMP_VENDA.CDCAIXA     AND
                   TMP_ITVENDACAN.NRSEQVENDA = TMP_VENDA.NRSEQVENDA;
         END LOOP;
      END LOOP;

      FOR TMP_ITVENDACAN IN (SELECT * FROM TMP_ITVENDACAN WHERE STATUS = 'N') LOOP
         INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,NRSEQVENDA,NRSEQUITVEND,DESCRICAO) VALUES (TMP_ITVENDACAN.CDFILIAL,TMP_ITVENDACAN.CDCAIXA,TMP_ITVENDACAN.NRSEQVENDA,TMP_ITVENDACAN.NRSEQUITVENDC,'ITEM CANCELADO SEM VENDA CORRESPONDENTE');
      END LOOP;
      /*Fim*/

      UPDATE TMP_ITEMVENDA
         SET STATUS = 'N';

      /*Valida se existe item sem imposto*/
      FOR TMP_ITEMVENDA IN (SELECT * FROM TMP_ITEMVENDA) LOOP
         FOR TMP_ITVENDAIMPOS IN (SELECT * FROM TMP_ITVENDAIMPOS) LOOP
            UPDATE TMP_ITEMVENDA
               SET STATUS = 'S'
             WHERE TMP_ITEMVENDA.CDFILIAL     = TMP_ITVENDAIMPOS.CDFILIAL      AND
                   TMP_ITEMVENDA.CDCAIXA      = TMP_ITVENDAIMPOS.CDCAIXA       AND
                   TMP_ITEMVENDA.NRSEQVENDA   = TMP_ITVENDAIMPOS.NRSEQVENDA    AND
                   TMP_ITEMVENDA.NRSEQUITVEND = TMP_ITVENDAIMPOS.NRSEQUITVEND;
         END LOOP;
      END LOOP;

      FOR TMP_ITEMVENDA IN (SELECT * FROM TMP_ITEMVENDA WHERE STATUS = 'N') LOOP
         INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,NRSEQVENDA,NRSEQUITVEND,DESCRICAO) VALUES (TMP_ITEMVENDA.CDFILIAL,TMP_ITEMVENDA.CDCAIXA,TMP_ITEMVENDA.NRSEQVENDA,TMP_ITEMVENDA.NRSEQUITVEND,'ITEM SEM IMPOSTO');
      END LOOP;
      /*Fim*/

      UPDATE TMP_ITVENDAIMPOS
         SET STATUS = 'N';

      /*Valida se existe imposto sem item correspondente*/
      FOR TMP_ITVENDAIMPOS IN (SELECT * FROM TMP_ITVENDAIMPOS) LOOP
         FOR TMP_ITEMVENDA IN (SELECT * FROM TMP_ITEMVENDA) LOOP
            UPDATE TMP_ITVENDAIMPOS
               SET STATUS = 'S'
             WHERE TMP_ITEMVENDA.CDFILIAL     = TMP_ITVENDAIMPOS.CDFILIAL      AND
                   TMP_ITEMVENDA.CDCAIXA      = TMP_ITVENDAIMPOS.CDCAIXA       AND
                   TMP_ITEMVENDA.NRSEQVENDA   = TMP_ITVENDAIMPOS.NRSEQVENDA    AND
                   TMP_ITEMVENDA.NRSEQUITVEND = TMP_ITVENDAIMPOS.NRSEQUITVEND;
         END LOOP;
      END LOOP;

      FOR TMP_ITVENDAIMPOS IN (SELECT * FROM TMP_ITVENDAIMPOS WHERE STATUS = 'N') LOOP
         INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,NRSEQVENDA,NRSEQUITVEND,DESCRICAO) VALUES (TMP_ITVENDAIMPOS.CDFILIAL,TMP_ITVENDAIMPOS.CDCAIXA,TMP_ITVENDAIMPOS.NRSEQVENDA,TMP_ITVENDAIMPOS.NRSEQUITVEND,'IMPOSTO SEM ITEM CORRESPONDENTE');
      END LOOP;
      /*Fim*/

      UPDATE TMP_TURCAIXA
         SET STATUS = 'N';

      /*Valida dia com venda sem reduo Z*/
      FOR TMP_TURCAIXA IN (SELECT * FROM TMP_TURCAIXA) LOOP
         FOR TMP_REDUCAOZ IN (SELECT * FROM TMP_REDUCAOZ) LOOP
            UPDATE TMP_TURCAIXA
               SET STATUS = 'S'
             WHERE TMP_TURCAIXA.CDFILIAL     = TMP_REDUCAOZ.CDFILIAL    AND
                   TMP_TURCAIXA.CDCAIXA      = TMP_REDUCAOZ.CDCAIXA     AND
                   TMP_TURCAIXA.DTMOVTURCAIX = TMP_REDUCAOZ.DTREDUCAOZ;
         END LOOP;
      END LOOP;

      FOR TMP_TURCAIXA IN (SELECT * FROM TMP_TURCAIXA WHERE STATUS = 'N') LOOP
         INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTABERCAIX,DESCRICAO) VALUES (TMP_TURCAIXA.CDFILIAL,TMP_TURCAIXA.CDCAIXA,TMP_TURCAIXA.DTABERCAIX,'DIA SEM REDUO Z');
      END LOOP;
      /*Fim*/

      UPDATE TMP_REDUCAOZ
         SET STATUS='N';

      /*Valida Reduo Z sem dia correspondente*/
      FOR TMP_REDUCAOZ IN (SELECT * FROM TMP_REDUCAOZ) LOOP
         FOR TMP_TURCAIXA IN (SELECT * FROM TMP_TURCAIXA) LOOP
            UPDATE TMP_REDUCAOZ
               SET STATUS = 'S'
             WHERE TMP_TURCAIXA.CDFILIAL     = TMP_REDUCAOZ.CDFILIAL    AND
                   TMP_TURCAIXA.CDCAIXA      = TMP_REDUCAOZ.CDCAIXA     AND
                   TMP_TURCAIXA.DTMOVTURCAIX = TMP_REDUCAOZ.DTREDUCAOZ;
         END LOOP;
      END LOOP;

      FOR TMP_REDUCAOZ IN (SELECT * FROM TMP_REDUCAOZ WHERE STATUS = 'N') LOOP
         INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_REDUCAOZ.CDFILIAL,TMP_REDUCAOZ.CDCAIXA,TMP_REDUCAOZ.DTREDUCAOZ,'REDUO Z SEM DIA CORRESPONDENTE');
      END LOOP;
      /*Fim*/

      UPDATE TMP_REDUCAOZ
         SET STATUS='N';

      /*Valida Reduo Z sem imposto*/
      FOR TMP_REDUCAOZ IN (SELECT * FROM TMP_REDUCAOZ) LOOP
         FOR TMP_IMPOSTOREDZ IN (SELECT * FROM TMP_IMPOSTOREDZ) LOOP
            UPDATE TMP_REDUCAOZ
               SET STATUS = 'S'
             WHERE TMP_IMPOSTOREDZ.CDFILIAL   = TMP_REDUCAOZ.CDFILIAL    AND
                   TMP_IMPOSTOREDZ.CDCAIXA    = TMP_REDUCAOZ.CDCAIXA     AND
                   TMP_IMPOSTOREDZ.NRECFREDZ  = TMP_REDUCAOZ.NRECFREDZ   AND
                   TMP_IMPOSTOREDZ.DTREDUCAOZ = TMP_REDUCAOZ.DTREDUCAOZ;
         END LOOP;
      END LOOP;

      FOR TMP_REDUCAOZ IN (SELECT * FROM TMP_REDUCAOZ WHERE STATUS = 'N') LOOP
         INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_REDUCAOZ.CDFILIAL,TMP_REDUCAOZ.CDCAIXA,TMP_REDUCAOZ.DTREDUCAOZ,'REDUO Z SEM IMPOSTO');
      END LOOP;
      /*Fim*/

      UPDATE TMP_IMPOSTOREDZ
         SET STATUS='N';

      /*Valida imposto sem Reduo Z correspondente*/
      FOR TMP_IMPOSTOREDZ IN (SELECT * FROM TMP_IMPOSTOREDZ) LOOP
         FOR TMP_REDUCAOZ IN (SELECT * FROM TMP_REDUCAOZ) LOOP
            UPDATE TMP_IMPOSTOREDZ
               SET STATUS = 'S'
             WHERE TMP_IMPOSTOREDZ.CDFILIAL   = TMP_REDUCAOZ.CDFILIAL    AND
                   TMP_IMPOSTOREDZ.CDCAIXA    = TMP_REDUCAOZ.CDCAIXA     AND
                   TMP_IMPOSTOREDZ.NRECFREDZ  = TMP_REDUCAOZ.NRECFREDZ   AND
                   TMP_IMPOSTOREDZ.DTREDUCAOZ = TMP_REDUCAOZ.DTREDUCAOZ;
         END LOOP;
      END LOOP;

      FOR TMP_IMPOSTOREDZ IN (SELECT * FROM TMP_IMPOSTOREDZ WHERE STATUS = 'N') LOOP
         INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_IMPOSTOREDZ.CDFILIAL,TMP_IMPOSTOREDZ.CDCAIXA,TMP_IMPOSTOREDZ.DTREDUCAOZ,'IMPOSTO SEM REDUO Z CORRESPONDENTE');
      END LOOP;
      /*Fim*/

      UPDATE TMP_REDUCAOZ
         SET STATUS='N';

      /*Valida Reduo Z sem Forma de Pagamento*
      FOR TMP_REDUCAOZ IN (SELECT * FROM TMP_REDUCAOZ) LOOP
         FOR TMP_FORMPGTOREDZ IN (SELECT * FROM TMP_FORMPGTOREDZ) LOOP
            UPDATE TMP_REDUCAOZ
               SET STATUS = 'S'
             WHERE TMP_FORMPGTOREDZ.CDFILIAL   = TMP_REDUCAOZ.CDFILIAL    AND
                   TMP_FORMPGTOREDZ.CDCAIXA    = TMP_REDUCAOZ.CDCAIXA     AND
                   TMP_FORMPGTOREDZ.NRECFREDZ  = TMP_REDUCAOZ.NRECFREDZ   AND
                   TMP_FORMPGTOREDZ.DTREDUCAOZ = TMP_REDUCAOZ.DTREDUCAOZ;
         END LOOP;
      END LOOP;

      FOR TMP_REDUCAOZ IN (SELECT * FROM TMP_REDUCAOZ WHERE STATUS = 'N') LOOP
         INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_REDUCAOZ.CDFILIAL,TMP_REDUCAOZ.CDCAIXA,TMP_REDUCAOZ.DTREDUCAOZ,'REDUO Z SEM FORMA DE PAGAMENTO');
      END LOOP;
      /*Fim*

      UPDATE TMP_FORMPGTOREDZ
         SET STATUS='N';

      /*Valida Forma de Pagamento sem Reduo Z correspondente*
      FOR TMP_FORMPGTOREDZ IN (SELECT * FROM TMP_FORMPGTOREDZ) LOOP
         FOR TMP_REDUCAOZ IN (SELECT * FROM TMP_REDUCAOZ) LOOP
            UPDATE TMP_FORMPGTOREDZ
               SET STATUS = 'S'
             WHERE TMP_FORMPGTOREDZ.CDFILIAL   = TMP_REDUCAOZ.CDFILIAL    AND
                   TMP_FORMPGTOREDZ.CDCAIXA    = TMP_REDUCAOZ.CDCAIXA     AND
                   TMP_FORMPGTOREDZ.NRECFREDZ  = TMP_REDUCAOZ.NRECFREDZ   AND
                   TMP_FORMPGTOREDZ.DTREDUCAOZ = TMP_REDUCAOZ.DTREDUCAOZ;
         END LOOP;
      END LOOP;

      FOR TMP_FORMPGTOREDZ IN (SELECT * FROM TMP_FORMPGTOREDZ WHERE STATUS = 'N') LOOP
         INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_FORMPGTOREDZ.CDFILIAL,TMP_FORMPGTOREDZ.CDCAIXA,TMP_FORMPGTOREDZ.DTREDUCAOZ,'FORMA DE PAGAMENTO SEM REDUO Z CORRESPONDENTE');
      END LOOP;
      /*Fim*/

      SELECT COUNT(*)
        INTO V_CONTAERRO
        FROM ERROIMPORTVENDA;

      IF V_CONTAERRO > 0 THEN
         P_RETORNO := 'NOT';
      ELSE
          P_RETORNO := 'OK';
      END IF;

  /*FIM - VALIDAO DA ESTRUTURA DO ARQUIVO IMPORTADO*/

  ELSE

  /*INICIO - VALIDAO DAS INFORMAES DO ARQUIVO IMPORTADO*/

     FOR TMP_VENDA IN(SELECT * FROM TMP_VENDA) LOOP
        /*VALIDA VENDA COM NMERO DO CUPOM FISCAL VAZIO OU ZERADO*/
        IF ((TMP_VENDA.NRCUPOMFIS IS NULL) OR (TMP_VENDA.NRCUPOMFIS = '') OR (TMP_VENDA.NRCUPOMFIS='0000000000')) THEN
           INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,NRSEQVENDA,DTVENDA,DESCRICAO) VALUES (TMP_VENDA.CDFILIAL,TMP_VENDA.CDCAIXA,TMP_VENDA.NRSEQVENDA,TMP_VENDA.DTVENDA,'VENDA COM NMERO DO CUPOM FISCAL VAZIO OU ZERADO');
        END IF;
        /*Fim*/

        /*VALIDA VENDA COM NMERO DO CUPOM FISCAL REPETIDO*/
        SELECT COUNT(*)
          INTO V_CONTCUPOMFISC
          FROM TMP_VENDA V
         WHERE V.NRCUPOMFIS = TMP_VENDA.NRCUPOMFIS;

        IF(V_CONTCUPOMFISC > 1) THEN
          INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,NRSEQVENDA,DTVENDA,DESCRICAO) VALUES (TMP_VENDA.CDFILIAL,TMP_VENDA.CDCAIXA,TMP_VENDA.NRSEQVENDA,TMP_VENDA.DTVENDA,'VENDA COM NMERO DO CUPOM FISCAL REPETIDO');
        END IF;
        /*Fim*/
     END LOOP;

     FOR TMP_MOVCAIXA IN (SELECT * FROM TMP_MOVCAIXA) LOOP
         IF ((TMP_MOVCAIXA.CDTIPORECE = '') OR (TMP_MOVCAIXA.CDTIPORECE IS NULL)) THEN
            INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTABERCAIX,CDTIPORECE,DESCRICAO) VALUES (TMP_MOVCAIXA.CDFILIAL,TMP_MOVCAIXA.CDCAIXA,TMP_MOVCAIXA.DTABERCAIX,TMP_MOVCAIXA.CDTIPORECE,'MOVIMENTO DE CAIXA SEM TIPO DE RECEBIMENTO');
         END IF;
     END LOOP;

     FOR C_TMP_ITVENDAIMPOS IN (SELECT * FROM TMP_ITVENDAIMPOS) LOOP

        BEGIN
            SELECT MAX(CDIMPOSTO)
              INTO V_CDIMPOSTO
              FROM IMPOSTOVENDA
             WHERE CDIMPOSTOVD = C_TMP_ITVENDAIMPOS.CDIMPOSTO;
        EXCEPTION
             WHEN NO_DATA_FOUND THEN
                  V_CDIMPOSTO := NULL;
        END;
        IF V_CDIMPOSTO IS NULL THEN
           INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,NRSEQVENDA,NRSEQUITVEND,DESCRICAO) VALUES (C_TMP_ITVENDAIMPOS.CDFILIAL,C_TMP_ITVENDAIMPOS.CDCAIXA,C_TMP_ITVENDAIMPOS.NRSEQVENDA,C_TMP_ITVENDAIMPOS.NRSEQUITVEND,'IMPOSTO "'|| C_TMP_ITVENDAIMPOS.CDIMPOSTO ||'" DO ITEM NO RELACIONADO. FAA O RELACIONAMENTO NA TELA DE "RELACIONAMENTOS PARA IMPORTAO"');
        ELSE
          UPDATE TMP_ITVENDAIMPOS
             SET CDIMPOSTO = (SELECT MAX(CDIMPOSTO)
                                FROM IMPOSTOVENDA
                               WHERE CDIMPOSTOVD = C_TMP_ITVENDAIMPOS.CDIMPOSTO)
           WHERE CDFILIAL     = C_TMP_ITVENDAIMPOS.CDFILIAL      AND
                 CDCAIXA      = C_TMP_ITVENDAIMPOS.CDCAIXA       AND
                 NRSEQVENDA   = C_TMP_ITVENDAIMPOS.NRSEQVENDA    AND
                 NRSEQUITVEND = C_TMP_ITVENDAIMPOS.NRSEQUITVEND;
        END IF;
     END LOOP;

     FOR C_TMP_IMPOSTOREDZ IN (SELECT * FROM TMP_IMPOSTOREDZ) LOOP
        BEGIN
            SELECT MAX(CDIMPOSTO)
              INTO V_CDIMPOSTO
              FROM IMPOSTOVENDA
             WHERE CDIMPOSTOVD = C_TMP_IMPOSTOREDZ.CDIMPOSTO;
        EXCEPTION
             WHEN NO_DATA_FOUND THEN
                  V_CDIMPOSTO := NULL;
        END;

        IF V_CDIMPOSTO IS NULL THEN
           INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (C_TMP_IMPOSTOREDZ.CDFILIAL,C_TMP_IMPOSTOREDZ.CDCAIXA,C_TMP_IMPOSTOREDZ.DTREDUCAOZ,'IMPOSTO "'|| C_TMP_IMPOSTOREDZ.CDIMPOSTO ||'" DA REDUO Z NO RELACIONADO. FAA O RELACIONAMENTO NA TELA DE "RELACIONAMENTOS PARA IMPORTAO"');
        ELSE
          UPDATE TMP_IMPOSTOREDZ
             SET CDIMPOSTO = (SELECT MAX(CDIMPOSTO)
                                FROM IMPOSTOVENDA
                               WHERE CDIMPOSTOVD = C_TMP_IMPOSTOREDZ.CDIMPOSTO)
           WHERE CDFILIAL   = C_TMP_IMPOSTOREDZ.CDFILIAL
             AND CDCAIXA    = C_TMP_IMPOSTOREDZ.CDCAIXA
             AND DTREDUCAOZ = C_TMP_IMPOSTOREDZ.DTREDUCAOZ
             AND NRECFREDZ  = C_TMP_IMPOSTOREDZ.NRECFREDZ;
        END IF;
     END LOOP;

    /*Valida se o somatrio das vendas difere ao valor da reduo Z*/
    FOR REDUCAOZ IN (SELECT * FROM TMP_REDUCAOZ) LOOP
        BEGIN
            SELECT SUM(TRUNC(NVL(I.QTPRODVEND,0) * NVL(I.VRUNITVEND,0) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0),2))
              INTO V_VRTOTVENDA
              FROM TMP_ITEMVENDA I, TMP_VENDA V
             WHERE I.CDFILIAL   = V.CDFILIAL     AND
                   I.CDCAIXA    = V.CDCAIXA      AND
                   I.NRSEQVENDA = V.NRSEQVENDA   AND
                   V.CDFILIAL   = REDUCAOZ.CDFILIAL AND
                   V.CDCAIXA    = REDUCAOZ.CDCAIXA  AND
                   TO_CHAR(V.DTVENDA,'DD/MM/YYYY') = REDUCAOZ.DTREDUCAOZ; 
        EXCEPTION
             WHEN NO_DATA_FOUND THEN
                  V_VRTOTVENDA    := 0;
        END;
                
        BEGIN
            SELECT SUM(TRUNC(NVL(I.QTPRODVENDC,0) * NVL(I.VRUNITVENDC,0) - NVL(I.VRDESITVENDC,0) + NVL(I.VRACRITVENDC,0),2))
              INTO V_VRTOTVENDACAN
              FROM TMP_ITVENDACAN I, TMP_VENDA V
             WHERE I.CDFILIAL   = V.CDFILIAL     AND
                   I.CDCAIXA    = V.CDCAIXA      AND
                   I.NRSEQVENDA = V.NRSEQVENDA   AND
                   V.CDFILIAL   = REDUCAOZ.CDFILIAL AND
                   V.CDCAIXA    = REDUCAOZ.CDCAIXA  AND
                   TO_CHAR(V.DTVENDA,'DD/MM/YYYY') = REDUCAOZ.DTREDUCAOZ;
        EXCEPTION
             WHEN NO_DATA_FOUND THEN
                  V_VRTOTVENDACAN := 0;
        END;

        IF ((NVL(V_VRTOTVENDA,0)+NVL(V_VRTOTVENDACAN,0)) <> REDUCAOZ.VRVENBRUREDZ) THEN
           INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (REDUCAOZ.CDFILIAL,REDUCAOZ.CDCAIXA,REDUCAOZ.DTREDUCAOZ,'SOMATRIO DAS VENDAS DIFERE AO VALOR BRUTO DA REDUO Z');
        END IF;

     END LOOP;
     /*Fim*/

     /*Valida se o somatrio do ST difere do valor de ST da Reduo Z*/
     FOR TMP_REDUCAOZ IN (SELECT * FROM TMP_REDUCAOZ) LOOP
        BEGIN
            SELECT SUM(A.VRSTRIB), R.VRSTRIBREDZ
              INTO V_VRSTRIB, V_VRSTRIBREDZ
              FROM
                  (SELECT SUM(TRUNC(NVL(I.QTPRODVEND,0) * NVL(I.VRUNITVEND,0) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0),2)) AS VRSTRIB,
                          V.CDFILIAL,
                          V.CDCAIXA,
                          V.DTVENDA
                     FROM TMP_ITEMVENDA I, TMP_VENDA V, TMP_ITVENDAIMPOS IT, IMPOSTO IM
                    WHERE I.CDFILIAL   = V.CDFILIAL         AND
                          I.CDCAIXA    = V.CDCAIXA          AND
                          I.NRSEQVENDA = V.NRSEQVENDA       AND
                          V.CDFILIAL   = TMP_REDUCAOZ.CDFILIAL AND
                          V.CDCAIXA    = TMP_REDUCAOZ.CDCAIXA  AND
                          TO_CHAR(V.DTVENDA,'DD/MM/YYYY') = TO_CHAR(TMP_REDUCAOZ.DTREDUCAOZ,'DD/MM/YYYY') AND
                          IT.CDFILIAL  = I.CDFILIAL         AND
                          IT.CDFILIAL  = V.CDFILIAL         AND
                          IT.CDCAIXA   = I.CDCAIXA          AND
                          IT.CDCAIXA   = V.CDCAIXA          AND
                          IT.NRSEQVENDA = V.NRSEQVENDA      AND
                          IT.NRSEQVENDA = I.NRSEQVENDA      AND
                          IT.NRSEQUITVEND = I.NRSEQUITVEND  AND
                          IT.CDIMPOSTO    = IM.CDIMPOSTO    AND
                          IM.IDTPIMPOSFIS = 'F'
                 GROUP BY V.CDFILIAL, V.CDCAIXA, V.DTVENDA) A, TMP_REDUCAOZ R
             WHERE A.CDFILIAL = R.CDFILIAL     AND
                   A.CDCAIXA  = R.CDCAIXA      AND
                   TO_CHAR(R.DTREDUCAOZ,'DD/MM/YYYY') = TO_CHAR(TMP_REDUCAOZ.DTREDUCAOZ,'DD/MM/YYYY')
          GROUP BY R.VRSTRIBREDZ;
        EXCEPTION
             WHEN NO_DATA_FOUND THEN
                  V_VRSTRIB     := NULL;
                  V_VRSTRIBREDZ := NULL;
        END;
        IF (V_VRSTRIB <> V_VRSTRIBREDZ) THEN
           INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_REDUCAOZ.CDFILIAL,TMP_REDUCAOZ.CDCAIXA,TO_CHAR(TMP_REDUCAOZ.DTREDUCAOZ,'DD/MM/YYYY'),'SOMTORIO DO ST DAS VENDAS DIFERE DO VALOR TOTAL DO ST DA REDUO Z');
        END IF;
     END LOOP;
     /*Fim*/

     /*Valida se o somatrio de Isentos difere do valor de Isentos da Reduo Z*/
     FOR TMP_REDUCAOZ IN (SELECT * FROM TMP_REDUCAOZ) LOOP
        BEGIN
            SELECT SUM(A.VRISENTO), R.VRISENCREDZ
              INTO V_VRISENTO, V_VRISENTOREDZ
              FROM
                  (SELECT SUM(TRUNC(NVL(I.QTPRODVEND,0) * NVL(I.VRUNITVEND,0) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0),2)) AS VRISENTO,
                          V.CDFILIAL,
                          V.CDCAIXA,
                          V.DTVENDA
                     FROM TMP_ITEMVENDA I, TMP_VENDA V, TMP_ITVENDAIMPOS IT, IMPOSTO IM
                    WHERE I.CDFILIAL   = V.CDFILIAL         AND
                          I.CDCAIXA    = V.CDCAIXA          AND
                          I.NRSEQVENDA = V.NRSEQVENDA       AND
                          V.CDFILIAL   = TMP_REDUCAOZ.CDFILIAL AND
                          V.CDCAIXA    = TMP_REDUCAOZ.CDCAIXA  AND
                          TO_CHAR(V.DTVENDA,'DD/MM/YYYY') = TO_CHAR(TMP_REDUCAOZ.DTREDUCAOZ,'DD/MM/YYYY') AND
                          IT.CDFILIAL  = I.CDFILIAL         AND
                          IT.CDFILIAL  = V.CDFILIAL         AND
                          IT.CDCAIXA   = I.CDCAIXA          AND
                          IT.CDCAIXA   = V.CDCAIXA          AND
                          IT.NRSEQVENDA = V.NRSEQVENDA      AND
                          IT.NRSEQVENDA = I.NRSEQVENDA      AND
                          IT.NRSEQUITVEND = I.NRSEQUITVEND  AND
                          IT.CDIMPOSTO    = IM.CDIMPOSTO    AND
                          IM.IDTPIMPOSFIS = 'I'
                 GROUP BY V.CDFILIAL, V.CDCAIXA, V.DTVENDA) A, TMP_REDUCAOZ R
                    WHERE A.CDFILIAL = R.CDFILIAL     AND
                          A.CDCAIXA  = R.CDCAIXA      AND
                          TO_CHAR(R.DTREDUCAOZ,'DD/MM/YYYY') = TO_CHAR(TMP_REDUCAOZ.DTREDUCAOZ,'DD/MM/YYYY')
          GROUP BY R.VRISENCREDZ;
        EXCEPTION
             WHEN NO_DATA_FOUND THEN
                  V_VRISENTO     := NULL;
                  V_VRISENTOREDZ := NULL;
        END;
        IF (V_VRISENTO <> V_VRISENTOREDZ) THEN
           INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_REDUCAOZ.CDFILIAL,TMP_REDUCAOZ.CDCAIXA,TO_CHAR(TMP_REDUCAOZ.DTREDUCAOZ,'DD/MM/YYYY'),'SOMTORIO DE ISENTOS DIFERE DO VALOR TOTAL DE ISENTOS DA REDUO Z');
        END IF;
     END LOOP;
     /*Fim*/

     /*Valida se o somatrio de No Tributados difere do valor de No Tributados da Reduo Z*/
     FOR TMP_REDUCAOZ IN (SELECT * FROM TMP_REDUCAOZ) LOOP
        BEGIN
            SELECT SUM(A.VRNINCID), R.VRNINCIDREDZ
              INTO V_VRNINCID, V_VRNINCIDREDZ
              FROM
                  (SELECT SUM(TRUNC(NVL(I.QTPRODVEND,0) * NVL(I.VRUNITVEND,0) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0),2)) AS VRNINCID,
                          V.CDFILIAL,
                          V.CDCAIXA,
                          V.DTVENDA
                     FROM TMP_ITEMVENDA I, TMP_VENDA V, TMP_ITVENDAIMPOS IT, IMPOSTO IM
                    WHERE I.CDFILIAL   = V.CDFILIAL         AND
                          I.CDCAIXA    = V.CDCAIXA          AND
                          I.NRSEQVENDA = V.NRSEQVENDA       AND
                          V.CDFILIAL   = TMP_REDUCAOZ.CDFILIAL AND
                          V.CDCAIXA    = TMP_REDUCAOZ.CDCAIXA  AND
                          TO_CHAR(V.DTVENDA,'DD/MM/YYYY') = TO_CHAR(TMP_REDUCAOZ.DTREDUCAOZ,'DD/MM/YYYY') AND
                          IT.CDFILIAL  = I.CDFILIAL         AND
                          IT.CDFILIAL  = V.CDFILIAL         AND
                          IT.CDCAIXA   = I.CDCAIXA          AND
                          IT.CDCAIXA   = V.CDCAIXA          AND
                          IT.NRSEQVENDA = V.NRSEQVENDA      AND
                          IT.NRSEQVENDA = I.NRSEQVENDA      AND
                          IT.NRSEQUITVEND = I.NRSEQUITVEND  AND
                          IT.CDIMPOSTO    = IM.CDIMPOSTO    AND
                          IM.IDTPIMPOSFIS = 'N'
                 GROUP BY V.CDFILIAL, V.CDCAIXA, V.DTVENDA) A, TMP_REDUCAOZ R
                    WHERE A.CDFILIAL = R.CDFILIAL     AND
                          A.CDCAIXA  = R.CDCAIXA      AND
                          TO_CHAR(R.DTREDUCAOZ,'DD/MM/YYYY') = TO_CHAR(TMP_REDUCAOZ.DTREDUCAOZ,'DD/MM/YYYY')
          GROUP BY R.VRNINCIDREDZ;
        EXCEPTION
             WHEN NO_DATA_FOUND THEN
                  V_VRNINCID     := NULL;
                  V_VRNINCIDREDZ := NULL;
        END;
        IF (V_VRNINCID <> V_VRNINCIDREDZ) THEN
           INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_REDUCAOZ.CDFILIAL,TMP_REDUCAOZ.CDCAIXA,TO_CHAR(TMP_REDUCAOZ.DTREDUCAOZ,'DD/MM/YYYY'),'SOMTORIO DE NO TRIBUTADOS DIFERE DO VALOR TOTAL DE NO TRIBUTADOS DA REDUO Z');
        END IF;
     END LOOP;
     /*Fim*/


     /*Valida se o somatrio de ISS difere do valor de ISS da Reduo Z*/
     FOR TMP_REDUCAOZ IN (SELECT * FROM TMP_REDUCAOZ) LOOP
        BEGIN
            SELECT SUM(A.VRISS), R.VRISSREDZ
              INTO V_VRISS, V_VRISSREDZ
              FROM
                  (SELECT SUM(TRUNC(NVL(I.QTPRODVEND,0) * NVL(I.VRUNITVEND,0) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0),2)) AS VRISS,
                          V.CDFILIAL,
                          V.CDCAIXA,
                          V.DTVENDA
                     FROM TMP_ITEMVENDA I, TMP_VENDA V, TMP_ITVENDAIMPOS IT, IMPOSTO IM
                    WHERE I.CDFILIAL   = V.CDFILIAL         AND
                          I.CDCAIXA    = V.CDCAIXA          AND
                          I.NRSEQVENDA = V.NRSEQVENDA       AND
                          V.CDFILIAL   = TMP_REDUCAOZ.CDFILIAL AND
                          V.CDCAIXA    = TMP_REDUCAOZ.CDCAIXA  AND
                          TO_CHAR(V.DTVENDA,'DD/MM/YYYY') = TO_CHAR(TMP_REDUCAOZ.DTREDUCAOZ,'DD/MM/YYYY') AND
                          IT.CDFILIAL  = I.CDFILIAL         AND
                          IT.CDFILIAL  = V.CDFILIAL         AND
                          IT.CDCAIXA   = I.CDCAIXA          AND
                          IT.CDCAIXA   = V.CDCAIXA          AND
                          IT.NRSEQVENDA = V.NRSEQVENDA      AND
                          IT.NRSEQVENDA = I.NRSEQVENDA      AND
                          IT.NRSEQUITVEND = I.NRSEQUITVEND  AND
                          IT.CDIMPOSTO    = IM.CDIMPOSTO    AND
                          IM.IDTPIMPOSFIS = 'S'
                 GROUP BY V.CDFILIAL, V.CDCAIXA, V.DTVENDA) A, TMP_REDUCAOZ R
                    WHERE A.CDFILIAL = R.CDFILIAL     AND
                          A.CDCAIXA  = R.CDCAIXA      AND
                          TO_CHAR(R.DTREDUCAOZ,'DD/MM/YYYY') = TO_CHAR(TMP_REDUCAOZ.DTREDUCAOZ,'DD/MM/YYYY')
          GROUP BY R.VRISSREDZ;
        EXCEPTION
             WHEN NO_DATA_FOUND THEN
                  V_VRISS     := NULL;
                  V_VRISSREDZ := NULL;
        END;
        IF (V_VRISS <> V_VRISSREDZ) THEN
           INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_REDUCAOZ.CDFILIAL,TMP_REDUCAOZ.CDCAIXA,TO_CHAR(TMP_REDUCAOZ.DTREDUCAOZ,'DD/MM/YYYY'),'SOMTORIO DO ISS DIFERE DO VALOR TOTAL DE ISS DA REDUO Z');
        END IF;
     END LOOP;
     /*Fim*/

     /*Valida se o somatrio do ICMS difere do valor de ICMS da Reduo Z*
     FOR TMP_REDUCAOZ IN (SELECT * FROM TMP_REDUCAOZ) LOOP
        BEGIN
            SELECT SUM(A.V_VRSTRIB) AS VRIMPOSTO, I.VRBCALCIMPRZ
              INTO V_VRTRIBUTADO, V_VRTRIBUTADOREDZ
              FROM
                  (SELECT SUM(TRUNC(NVL(I.QTPRODVEND,0) * NVL(I.VRUNITVEND,0) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0),2)) AS V_VRSTRIB,
                          V.CDFILIAL,
                          V.CDCAIXA,
                          V.DTVENDA
                     FROM TMP_ITEMVENDA I, TMP_VENDA V, TMP_ITVENDAIMPOS IT, IMPOSTO IM
                    WHERE I.CDFILIAL   = V.CDFILIAL         AND
                          I.CDCAIXA    = V.CDCAIXA          AND
                          I.NRSEQVENDA = V.NRSEQVENDA       AND
                          V.CDFILIAL   = TMP_REDUCAOZ.CDFILIAL AND
                          V.CDCAIXA    = TMP_REDUCAOZ.CDCAIXA  AND
                          TO_CHAR(V.DTVENDA,'DD/MM/YYYY') = TO_CHAR(TMP_REDUCAOZ.DTREDUCAOZ,'DD/MM/YYYY') AND
                          IT.CDFILIAL  = I.CDFILIAL         AND
                          IT.CDFILIAL  = V.CDFILIAL         AND
                          IT.CDCAIXA   = I.CDCAIXA          AND
                          IT.CDCAIXA   = V.CDCAIXA          AND
                          IT.NRSEQVENDA = V.NRSEQVENDA      AND
                          IT.NRSEQVENDA = I.NRSEQVENDA      AND
                          IT.NRSEQUITVEND = I.NRSEQUITVEND  AND
                          IT.CDIMPOSTO    = IM.CDIMPOSTO    AND
                          IM.IDTPIMPOSFIS = 'T'
                 GROUP BY V.CDFILIAL, V.CDCAIXA, V.DTVENDA) A, TMP_REDUCAOZ R, TMP_IMPOSTOREDZ I
             WHERE A.CDFILIAL = R.CDFILIAL     AND
                   A.CDCAIXA  = R.CDCAIXA      AND
                   I.DTREDUCAOZ = R.DTREDUCAOZ AND
                   I.CDFILIAL = R.CDFILIAL     AND
                   I.CDCAIXA  = R.CDCAIXA      AND
                   TO_CHAR(R.DTREDUCAOZ,'DD/MM/YYYY') = TO_CHAR(TMP_REDUCAOZ.DTREDUCAOZ,'DD/MM/YYYY')
          GROUP BY I.VRBCALCIMPRZ;
        EXCEPTION
             WHEN NO_DATA_FOUND THEN
                  V_VRTRIBUTADOREDZ := NULL;
                  V_VRTRIBUTADO     := NULL;
        END;
        IF (V_VRTRIBUTADO <> V_VRTRIBUTADOREDZ) THEN
           INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_REDUCAOZ.CDFILIAL,TMP_REDUCAOZ.CDCAIXA,TO_CHAR(TMP_REDUCAOZ.DTREDUCAOZ,'DD/MM/YYYY'),'SOMTORIO DOS ITENS TRIBUTADOS DIFERE DO VALOR TOTAL TRIBUTADO DA REDUO Z');
        END IF;
     END LOOP;
     /*Fim*/

     /*Valida se o somatrio do ICMS difere do valor de ICMS da Reduo Z*/
     FOR TMP_REDUCAOZ IN (SELECT * FROM TMP_REDUCAOZ) LOOP
        BEGIN
            SELECT SUM(A.V_VRSTRIB) AS VRIMPOSTO, I.VRBCALCIMPRZ
              INTO V_VRTRIBUTADO, V_VRTRIBUTADOREDZ
              FROM
                  (SELECT SUM(TRUNC(NVL(I.QTPRODVEND,0) * NVL(I.VRUNITVEND,0) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0),2)) AS V_VRSTRIB,
                          V.CDFILIAL,
                          V.CDCAIXA,
                          V.DTVENDA
                     FROM TMP_ITEMVENDA I, TMP_VENDA V, TMP_ITVENDAIMPOS IT, IMPOSTO IM
                    WHERE I.CDFILIAL   = V.CDFILIAL         AND
                          I.CDCAIXA    = V.CDCAIXA          AND
                          I.NRSEQVENDA = V.NRSEQVENDA       AND
                          V.CDFILIAL   = TMP_REDUCAOZ.CDFILIAL AND
                          V.CDCAIXA    = TMP_REDUCAOZ.CDCAIXA  AND
                          TO_CHAR(V.DTVENDA,'DD/MM/YYYY') = TO_CHAR(TMP_REDUCAOZ.DTREDUCAOZ,'DD/MM/YYYY') AND
                          IT.CDFILIAL  = I.CDFILIAL         AND
                          IT.CDFILIAL  = V.CDFILIAL         AND
                          IT.CDCAIXA   = I.CDCAIXA          AND
                          IT.CDCAIXA   = V.CDCAIXA          AND
                          IT.NRSEQVENDA = V.NRSEQVENDA      AND
                          IT.NRSEQVENDA = I.NRSEQVENDA      AND
                          IT.NRSEQUITVEND = I.NRSEQUITVEND  AND
                          IT.CDIMPOSTO    = IM.CDIMPOSTO    AND
                          IM.IDTPIMPOSFIS = 'T'
                 GROUP BY V.CDFILIAL, V.CDCAIXA, V.DTVENDA) A, (SELECT SUM(I.VRBCALCIMPRZ) AS VRBCALCIMPRZ
                                                                  FROM TMP_IMPOSTOREDZ I
                                                                 WHERE I.CDFILIAL = TMP_REDUCAOZ.CDFILIAL
                                                                   AND I.CDCAIXA  = TMP_REDUCAOZ.CDCAIXA
                                                                   AND TO_CHAR(I.DTREDUCAOZ,'DD/MM/YYYY') = TO_CHAR(TMP_REDUCAOZ.DTREDUCAOZ,'DD/MM/YYYY')) I
          GROUP BY I.VRBCALCIMPRZ;
        EXCEPTION
             WHEN NO_DATA_FOUND THEN
                  V_VRTRIBUTADOREDZ := NULL;
                  V_VRTRIBUTADO     := NULL;
        END;
        IF (V_VRTRIBUTADO <> V_VRTRIBUTADOREDZ) THEN
           INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_REDUCAOZ.CDFILIAL,TMP_REDUCAOZ.CDCAIXA,TO_CHAR(TMP_REDUCAOZ.DTREDUCAOZ,'DD/MM/YYYY'),'SOMTORIO DOS ITENS TRIBUTADOS DIFERE DO VALOR TOTAL TRIBUTADO DA REDUO Z');
        END IF;
     END LOOP;
     /*Fim*/

     /*Valida se a Venda Liquida da Reduo Z difere do somatrios dos impostos da Reduo Z*/
     FOR TMP_REDUCAOZ IN (SELECT * FROM TMP_REDUCAOZ) LOOP
        BEGIN
            SELECT (A.IMPOSTO + B.ICMS), RE.VRVENLIQREDZ
              INTO V_VRTOTIMPOSTO, V_VRVENLIQREDZ
              FROM (SELECT CDFILIAL, CDCAIXA, DTREDUCAOZ, SUM(VRVENLIQREDZ) AS VRVENLIQREDZ
                      FROM TMP_REDUCAOZ
                     WHERE CDFILIAL   = TMP_REDUCAOZ.CDFILIAL
                       AND CDCAIXA    = TMP_REDUCAOZ.CDCAIXA
                       AND DTREDUCAOZ = TMP_REDUCAOZ.DTREDUCAOZ
                  GROUP BY CDFILIAL, CDCAIXA, DTREDUCAOZ
                  ORDER BY DTREDUCAOZ) RE,

                   (SELECT RE.CDFILIAL, RE.CDCAIXA, RE.DTREDUCAOZ, SUM(NVL(RE.VRSTRIBREDZ,0) + NVL(RE.VRISENCREDZ,0) + NVL(RE.VRNINCIDREDZ, 0)) AS IMPOSTO
                      FROM TMP_REDUCAOZ RE
                     WHERE CDFILIAL   = TMP_REDUCAOZ.CDFILIAL
                       AND CDCAIXA    = TMP_REDUCAOZ.CDCAIXA
                       AND DTREDUCAOZ = TMP_REDUCAOZ.DTREDUCAOZ
                  GROUP BY RE.CDFILIAL, RE.CDCAIXA, RE.DTREDUCAOZ) A,

                   (SELECT IM.CDFILIAL, IM.CDCAIXA, IM.DTREDUCAOZ, SUM(NVL(IM.VRBCALCIMPRZ,0)) AS ICMS
                      FROM TMP_IMPOSTOREDZ IM
                     WHERE CDFILIAL   = TMP_REDUCAOZ.CDFILIAL
                       AND CDCAIXA    = TMP_REDUCAOZ.CDCAIXA
                       AND DTREDUCAOZ = TMP_REDUCAOZ.DTREDUCAOZ
                  GROUP BY IM.CDFILIAL, IM.CDCAIXA, IM.DTREDUCAOZ) B
             WHERE RE.CDFILIAL   = A.CDFILIAL
               AND B.CDFILIAL    = A.CDFILIAL
               AND RE.CDCAIXA    = A.CDCAIXA
               AND B.CDCAIXA     = A.CDCAIXA
               AND RE.DTREDUCAOZ = A.DTREDUCAOZ
               AND B.DTREDUCAOZ  = A.DTREDUCAOZ
             ORDER BY RE.CDFILIAL, RE.CDCAIXA, RE.DTREDUCAOZ;
        EXCEPTION
             WHEN NO_DATA_FOUND THEN
                  V_VRTOTIMPOSTO := NULL;
                  V_VRVENLIQREDZ := NULL;
        END;
        IF (V_VRTOTIMPOSTO <> V_VRVENLIQREDZ) THEN
           INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_REDUCAOZ.CDFILIAL,TMP_REDUCAOZ.CDCAIXA,TO_CHAR(TMP_REDUCAOZ.DTREDUCAOZ,'DD/MM/YYYY'),'Venda Liquida da Reduo Z difere do somatrios dos impostos da Reduo Z (ST, ISENTO, no tributado e ICMS)');
        END IF;
     END LOOP;
     /*Fim*/


     /*Valida se a Venda Liquida da Reduo Z difere do somatrios dos impostos da Reduo Z*
     FOR TMP_VENDA IN (SELECT * FROM TMP_VENDA) LOOP
        SELECT ROUND(SUM(VRIMPOSTO)-NVL(VRISENCREDZ,0.00)-NVL(VRNINCIDREDZ,0.00),2) AS VRIMPOSTOT, VRVENLIQREDZ
          INTO V_VRTOTIMPOSTO, V_VRVENLIQREDZ
          FROM (
                SELECT (SUM(TRUNC(NVL(A.QTPRODVEND,0) * NVL(A.VRUNITVEND,0) - NVL(A.VRDESITVEND,0) + NVL(A.VRACRITVEND,0),2))-NVL(R.VRTOTCANREDZ,0.00)-NVL(R.VRTOTDESREDZ,0.00)) AS VRIMPOSTO,
                       R.VRVENLIQREDZ,
                       R.VRISENCREDZ,
                       R.VRNINCIDREDZ
                  FROM (
                        SELECT I.VRUNITVEND,I.QTPRODVEND,I.VRDESITVEND,I.VRACRITVEND,V.CDFILIAL, V.CDCAIXA, V.DTVENDA
                          FROM TMP_ITEMVENDA I, TMP_VENDA V, TMP_ITVENDAIMPOS IT, IMPOSTO IM
                         WHERE I.CDFILIAL   = V.CDFILIAL         AND
                               I.CDCAIXA    = V.CDCAIXA          AND
                               I.NRSEQVENDA = V.NRSEQVENDA       AND
                               V.CDCAIXA    = TMP_VENDA.CDCAIXA  AND
                               V.CDFILIAL   = TMP_VENDA.CDFILIAL AND
                               TO_CHAR(V.DTVENDA,'DD/MM/YYYY') = TO_CHAR(TMP_VENDA.DTVENDA,'DD/MM/YYYY') AND
                               IT.CDFILIAL  = I.CDFILIAL         AND
                               IT.CDFILIAL  = V.CDFILIAL         AND
                               IT.CDCAIXA   = I.CDCAIXA          AND
                               IT.CDCAIXA   = V.CDCAIXA          AND
                               IT.NRSEQVENDA = V.NRSEQVENDA      AND
                               IT.NRSEQVENDA = I.NRSEQVENDA      AND
                               IT.NRSEQUITVEND = I.NRSEQUITVEND  AND
                               IT.CDIMPOSTO    = IM.CDIMPOSTO    AND
                               IM.IDTPIMPOSFIS = 'T') A, TMP_REDUCAOZ R, TMP_IMPOSTOREDZ I
                 WHERE A.CDFILIAL = R.CDFILIAL     AND
                       A.CDCAIXA = R.CDCAIXA       AND
                       I.DTREDUCAOZ = R.DTREDUCAOZ AND
                       I.CDFILIAL = R.CDFILIAL     AND
                       I.CDCAIXA  = R.CDCAIXA      AND
                       TO_CHAR(A.DTVENDA,'DD/MM/YYYY') = TO_CHAR(R.DTREDUCAOZ,'DD/MM/YYYY')
              GROUP BY R.VRTOTCANREDZ,VRTOTDESREDZ, R.VRVENLIQREDZ, R.VRISENCREDZ, R.VRNINCIDREDZ
             UNION ALL
                SELECT SUM(A.VRUNITVEND*A.QTPRODVEND) AS VRIMPOSTO,
                       R.VRVENLIQREDZ,
                       R.VRISENCREDZ,
                       R.VRNINCIDREDZ
                 FROM (
                       SELECT I.VRUNITVEND, I.QTPRODVEND, V.CDFILIAL, V.CDCAIXA, V.DTVENDA
                         FROM TMP_ITEMVENDA I, TMP_VENDA V, TMP_ITVENDAIMPOS IT, IMPOSTO IM
                        WHERE I.CDFILIAL   = V.CDFILIAL         AND
                              I.CDCAIXA    = V.CDCAIXA          AND
                              I.NRSEQVENDA = V.NRSEQVENDA       AND
                              V.CDCAIXA    = TMP_VENDA.CDCAIXA  AND
                              V.CDFILIAL   = TMP_VENDA.CDFILIAL AND
                              TO_CHAR(V.DTVENDA,'DD/MM/YYYY') = TO_CHAR(TMP_VENDA.DTVENDA,'DD/MM/YYYY') AND
                              IT.CDFILIAL = I.CDFILIAL          AND
                              IT.CDFILIAL = V.CDFILIAL          AND
                              IT.CDCAIXA = I.CDCAIXA            AND
                              IT.CDCAIXA = V.CDCAIXA            AND
                              IT.NRSEQVENDA = V.NRSEQVENDA      AND
                              IT.NRSEQVENDA = I.NRSEQVENDA      AND
                              IT.NRSEQUITVEND = I.NRSEQUITVEND  AND
                              IT.CDIMPOSTO    = IM.CDIMPOSTO    AND
                              IM.IDTPIMPOSFIS = 'F') A, TMP_REDUCAOZ R, TMP_IMPOSTOREDZ I
                WHERE A.CDFILIAL = R.CDFILIAL     AND
                      A.CDCAIXA = R.CDCAIXA       AND
                      I.DTREDUCAOZ = R.DTREDUCAOZ AND
                      I.CDFILIAL = R.CDFILIAL     AND
                      I.CDCAIXA  = R.CDCAIXA      AND
                      TO_CHAR(A.DTVENDA,'DD/MM/YYYY') = TO_CHAR(R.DTREDUCAOZ,'DD/MM/YYYY')
             GROUP BY R.VRVENLIQREDZ, R.VRISENCREDZ, R.VRNINCIDREDZ)
      GROUP BY VRISENCREDZ,VRNINCIDREDZ,VRVENLIQREDZ;

        IF (V_VRTOTIMPOSTO <> V_VRVENLIQREDZ) THEN
           INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_VENDA.CDFILIAL,TMP_VENDA.CDCAIXA,TO_CHAR(TMP_VENDA.DTVENDA,'DD/MM/YYYY'),'Venda Liquida da Reduo Z difere do somatrios dos impostos da Reduo Z (ST, ISENTO, no tributado e ICMS)');
        END IF;

     END LOOP;

     /*Fim*/

     /*Valida informaes da reduo Z*/
     FOR TMP_REDUCAOZ IN (SELECT * FROM TMP_REDUCAOZ) LOOP
        IF ((TMP_REDUCAOZ.NRPRIMCFREDZ = '') OR (TMP_REDUCAOZ.NRPRIMCFREDZ IS NULL)) THEN
           INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_REDUCAOZ.CDFILIAL,TMP_REDUCAOZ.CDCAIXA,TMP_REDUCAOZ.DTREDUCAOZ,'Reduo Z como nmero de cupom fiscal inicial vazio');
        END IF;
        IF (TMP_REDUCAOZ.NRPRIMCFREDZ = '0000000000') THEN
           INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_REDUCAOZ.CDFILIAL,TMP_REDUCAOZ.CDCAIXA,TMP_REDUCAOZ.DTREDUCAOZ,'Reduo Z como nmero de cupom fiscal inicial zerado');
        END IF;
        IF (TMP_REDUCAOZ.NRPRIMCFREDZ > TMP_REDUCAOZ.NRULTCFREDZ) THEN
            INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_REDUCAOZ.CDFILIAL,TMP_REDUCAOZ.CDCAIXA,TMP_REDUCAOZ.DTREDUCAOZ,'Reduo Z como nmero de cupom fiscal inicial maior que o nmero de cupom fiscal final do dia');
        END IF;

        IF ((TMP_REDUCAOZ.NRULTCFREDZ = '') OR (TMP_REDUCAOZ.NRULTCFREDZ IS NULL)) THEN
           INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_REDUCAOZ.CDFILIAL,TMP_REDUCAOZ.CDCAIXA,TMP_REDUCAOZ.DTREDUCAOZ,'Reduo Z como nmero de cupom fiscal final vazio');
        END IF;
        IF (TMP_REDUCAOZ.NRULTCFREDZ = '0000000000') THEN
           INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_REDUCAOZ.CDFILIAL,TMP_REDUCAOZ.CDCAIXA,TMP_REDUCAOZ.DTREDUCAOZ,'Reduo Z como nmero de cupom fiscal final zerado');
        END IF;
        IF (TMP_REDUCAOZ.NRULTCFREDZ < TMP_REDUCAOZ.NRPRIMCFREDZ) THEN
           INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_REDUCAOZ.CDFILIAL,TMP_REDUCAOZ.CDCAIXA,TMP_REDUCAOZ.DTREDUCAOZ,'Reduo Z como nmero de cupom fiscal inicial menor que o nmero de cupom fiscal final do dia');
        END IF;

        IF ((TMP_REDUCAOZ.NRSERIEREDZ='') OR (TMP_REDUCAOZ.NRSERIEREDZ IS NULL)) THEN
           INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_REDUCAOZ.CDFILIAL,TMP_REDUCAOZ.CDCAIXA,TMP_REDUCAOZ.DTREDUCAOZ,'Reduo Z sem nmero de srie');
        END IF;

        IF ((TMP_REDUCAOZ.DSMODMARCAECF='') OR (TMP_REDUCAOZ.DSMODMARCAECF IS NULL)) THEN
           INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_REDUCAOZ.CDFILIAL,TMP_REDUCAOZ.CDCAIXA,TMP_REDUCAOZ.DTREDUCAOZ,'Reduo Z sem descrio do modelo/marca ECF');
        END IF;

        IF ((TMP_REDUCAOZ.NRREINIREDZ='') OR (TMP_REDUCAOZ.NRREINIREDZ IS NULL)) THEN
           INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_REDUCAOZ.CDFILIAL,TMP_REDUCAOZ.CDCAIXA,TMP_REDUCAOZ.DTREDUCAOZ,'Reduo Z sem nmero de reinicio');
        END IF;
     END LOOP;
     /*Fim*/

     /*Valida se o nmero do cupom das vendas esto fora do intervalo do cupom fiscal inicial e final da reduo z*/
     FOR TMP_VENDA IN (SELECT * FROM TMP_VENDA) LOOP
        SELECT NRPRIMCFREDZ, NRULTCFREDZ
          INTO V_NRPRIMCFREDZ, V_NRULTCFREDZ
          FROM TMP_REDUCAOZ
         WHERE CDFILIAL    = TMP_VENDA.CDFILIAL AND
               CDCAIXA     = TMP_VENDA.CDCAIXA  AND
               TO_CHAR(DTREDUCAOZ,'DD/MM/YYYY') = TO_CHAR(TMP_VENDA.DTVENDA,'DD/MM/YYYY');

        UPDATE TMP_VENDA
           SET STATUS = 'S'
         WHERE CDFILIAL  = TMP_VENDA.CDFILIAL   AND
               CDCAIXA   = TMP_VENDA.CDCAIXA    AND
               DTVENDA   = TMP_VENDA.DTVENDA    AND
               NRCUPOMFIS BETWEEN V_NRPRIMCFREDZ AND V_NRULTCFREDZ;
     END LOOP;

     FOR TMP_VENDA IN (SELECT * FROM TMP_VENDA WHERE STATUS = 'N') LOOP
        INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTVENDA,DESCRICAO) VALUES (TMP_VENDA.CDFILIAL,TMP_VENDA.CDCAIXA,TMP_VENDA.DTVENDA,'Nmero do cupon da venda fora do intervalo do cupom fiscal inicial e final da reduo z');
     END LOOP;
     /*Fim*/


     /*FOR TMP_VENDA IN (SELECT * FROM TMP_VENDA) LOOP

        BEGIN
             SELECT SUM((TRUNC(QTPRODVEND*VRUNITVEND,2)) - (NVL(VRDESITVEND,0)))
               INTO V_VRTOTVENDA
               FROM TMP_ITEMVENDA
              WHERE CDFILIAL   = TMP_VENDA.CDFILIAL    AND
                    CDCAIXA    = TMP_VENDA.CDCAIXA     AND
                    NRSEQVENDA = TMP_VENDA.NRSEQVENDA;
        EXCEPTION
             WHEN NO_DATA_FOUND THEN
                  V_VRTOTVENDA := 0;
        END;

        BEGIN
             SELECT ROUND(VRMOVIVEND,2)
               INTO V_VRENTRADAMOV
               FROM TMP_MOVCAIXA
              WHERE CDFILIAL     = TMP_VENDA.CDFILIAL   AND
                    CDCAIXA      = TMP_VENDA.CDCAIXA    AND
                    NRSEQVENDA   = TMP_VENDA.NRSEQVENDA AND
                    DTABERCAIX   = TMP_VENDA.DTABERTUR  AND
                    IDTIPOMOVIVE = 'E';
        EXCEPTION
             WHEN NO_DATA_FOUND THEN
                  V_VRENTRADAMOV := 0;
        END;

        IF (V_VRENTRADAMOV <> V_VRTOTVENDA) THEN
            INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTVENDA,DESCRICAO) VALUES (TMP_VENDA.CDFILIAL,TMP_VENDA.CDCAIXA,TMP_VENDA.DTVENDA,'VALOR TOTAL DE RECEBIMENTOS DIFERE DO VALOR DA VENDA');
        END IF;
     END LOOP;*/

     SELECT COUNT(*)
       INTO V_CONTAERRO
       FROM ERROIMPORTVENDA;

     IF V_CONTAERRO > 0 THEN
       P_RETORNO := 'NOT';
       V_IMPORTA := 'NOT';
     ELSE
       P_RETORNO := 'OK';
       V_IMPORTA := 'OK';
     END IF;

  END IF;

  /*FIM - VALIDAO DAS INFORMAES DO ARQUIVO IMPORTADO*/

  IF V_IMPORTA = 'OK' THEN

    /*INICIO - BUSCA E VALIDA OS RELACIONAMENTOS "DE/PARA" */

    UPDATE TMP_TURCAIXA
       SET STATUS = 'N';

    FOR TMP_TURCAIXA IN (SELECT * FROM TMP_TURCAIXA) LOOP

       BEGIN
           SELECT CDFILIAL, CDCAIXA, CDLOJA
             INTO V_CDFILIAL, V_CDCAIXA, V_CDLOJA
             FROM CAIXAVENDA
            WHERE CDFILIALVD = TMP_TURCAIXA.CDFILIAL
              AND CDCAIXAVD  = TMP_TURCAIXA.CDCAIXA;
       EXCEPTION
            WHEN NO_DATA_FOUND THEN
                 V_CDFILIAL := NULL;
                 V_CDCAIXA  := NULL;
       END;

       IF V_CDFILIAL IS NULL OR V_CDCAIXA IS NULL THEN
          INSERT INTO ERROIMPORTVENDA(CDFILIAL,CDCAIXA,DESCRICAO) VALUES (TMP_TURCAIXA.CDFILIAL,TMP_TURCAIXA.CDCAIXA,'FILIAL E CAIXA NO RELACIONADOS. FAA O RELACIONAMENTO NA TELA DE "RELACIONAMENTOS PARA IMPORTAO"');
       ELSE
          BEGIN
               INSERT INTO TURCAIXA (CDFILIAL,CDCAIXA,DTABERCAIX,DTFECHCAIX,DTMOVTURCAIX,NRECFTURCAIX,CDOPERADOR)
                    VALUES (V_CDFILIAL,V_CDCAIXA,TO_DATE(TMP_TURCAIXA.DTABERCAIX, 'DD/MM/YYYY HH24:MI:SS'),TO_DATE(TMP_TURCAIXA.DTFECHCAIX, 'DD/MM/YYYY HH24:MI:SS'), TMP_TURCAIXA.DTMOVTURCAIX,TMP_TURCAIXA.NRECFTURCAIX,TMP_TURCAIXA.CDOPERADOR);
          EXCEPTION
               WHEN DUP_VAL_ON_INDEX THEN
                    V_EXISTE := 'S';
                    UPDATE TMP_TURCAIXA
                       SET STATUS = 'S'
                     WHERE CDFILIAL   = TMP_TURCAIXA.CDFILIAL
                       AND CDCAIXA    = TMP_TURCAIXA.CDCAIXA
                       AND DTABERCAIX = TMP_TURCAIXA.DTABERCAIX;
          END;
       END IF;

       FOR TMP_VENDA IN (SELECT *
                           FROM TMP_VENDA
                          WHERE CDFILIALTUR = TMP_TURCAIXA.CDFILIAL
                            AND CDCAIXATUR  = TMP_TURCAIXA.CDCAIXA
                            AND DTABERTUR   = TMP_TURCAIXA.DTABERCAIX) LOOP
          BEGIN
               SELECT MAX(CDCLIENTE)
                 INTO V_CDCLIENTE
                 FROM CLIENTEVENDA
                WHERE CDCLIENTEVD = TMP_VENDA.CDCLIENTE;
          EXCEPTION
               WHEN NO_DATA_FOUND THEN
                    V_CDCLIENTE := NULL;
          END;
          IF V_CDCLIENTE IS NULL THEN
             INSERT INTO ERROIMPORTVENDA(CDFILIAL,CDCAIXA,NRSEQVENDA,CDCLIENTE,DESCRICAO) VALUES (TMP_VENDA.CDFILIAL,TMP_VENDA.CDCAIXA,TMP_VENDA.NRSEQVENDA,TMP_VENDA.CDCLIENTE,'CLIENTE DA VENDA NO RELACIONADO. FAA O RELACIONAMENTO NA TELA DE "RELACIONAMENTOS PARA IMPORTAO"');
          END IF;

          FOR TMP_ITEMVENDA IN (SELECT *
                                  FROM TMP_ITEMVENDA
                                 WHERE CDFILIAL   = TMP_VENDA.CDFILIAL
                                   AND CDCAIXA    = TMP_VENDA.CDCAIXA
                                   AND NRSEQVENDA = TMP_VENDA.NRSEQVENDA) LOOP

             BEGIN
                  SELECT MAX(CDPRODUTO)
                    INTO V_CDPRODUTO
                    FROM PRODUTOVENDA
                   WHERE CDPRODUTOVD = TMP_ITEMVENDA.CDPRODUTO;
             EXCEPTION
                 WHEN NO_DATA_FOUND THEN
                      V_CDPRODUTO := NULL;
             END;

             IF V_CDPRODUTO IS NULL THEN
                INSERT INTO ERROIMPORTVENDA(CDFILIAL,CDCAIXA,NRSEQVENDA,NRSEQUITVEND,CDPRODUTO,DESCRICAO) VALUES (TMP_ITEMVENDA.CDFILIAL,TMP_ITEMVENDA.CDCAIXA,TMP_ITEMVENDA.NRSEQVENDA,TMP_ITEMVENDA.NRSEQUITVEND,TMP_ITEMVENDA.CDPRODUTO,'PRODUTO DA VENDA NO RELACIONADO. FAA O RELACIONAMENTO NA TELA DE "RELACIONAMENTOS PARA IMPORTAO"');
             END IF;
          END LOOP;

          FOR TMP_ITVENDACAN IN (SELECT *
                                  FROM TMP_ITVENDACAN
                                 WHERE CDFILIAL   = TMP_VENDA.CDFILIAL
                                   AND CDCAIXA    = TMP_VENDA.CDCAIXA
                                   AND NRSEQVENDA = TMP_VENDA.NRSEQVENDA) LOOP

             BEGIN
                  SELECT MAX(CDPRODUTO)
                    INTO V_CDPRODUTO
                    FROM PRODUTOVENDA
                   WHERE CDPRODUTOVD = TMP_ITVENDACAN.CDPRODUTO;
             EXCEPTION
                 WHEN NO_DATA_FOUND THEN
                      V_CDPRODUTO := NULL;
             END;

             IF V_CDPRODUTO IS NULL THEN
                INSERT INTO ERROIMPORTVENDA(CDFILIAL,CDCAIXA,NRSEQVENDA,NRSEQUITVEND,CDPRODUTO,DESCRICAO) VALUES (TMP_ITVENDACAN.CDFILIAL,TMP_ITVENDACAN.CDCAIXA,TMP_ITVENDACAN.NRSEQVENDA,TMP_ITVENDACAN.NRSEQUITVENDC,TMP_ITVENDACAN.CDPRODUTO,'PRODUTO CANCELADO DA VENDA NO RELACIONADO. FAA O RELACIONAMENTO NA TELA DE "RELACIONAMENTOS PARA IMPORTAO"');
             END IF;
          END LOOP;
       END LOOP;


       FOR TMP_MOVCAIXA IN (SELECT *
                              FROM TMP_MOVCAIXA
                             WHERE CDFILIAL = TMP_TURCAIXA.CDFILIAL
                               AND CDCAIXA  = TMP_TURCAIXA.CDCAIXA
                               AND DTABERCAIX = TMP_TURCAIXA.DTABERCAIX) LOOP
          BEGIN
              SELECT MAX(CDTIPORECE)
                INTO V_CDTIPORECE
                FROM TPRECEVENDA
               WHERE CDTIPORECEVD = TMP_MOVCAIXA.CDTIPORECE;
          EXCEPTION
               WHEN NO_DATA_FOUND THEN
                    V_CDTIPORECE := NULL;
          END;

          IF V_CDTIPORECE IS NULL THEN
            INSERT INTO ERROIMPORTVENDA(CDFILIAL,CDCAIXA,DTABERCAIX,CDTIPORECE,DESCRICAO) VALUES (V_CDFILIAL,V_CDCAIXA,TMP_MOVCAIXA.DTABERCAIX,TMP_MOVCAIXA.CDTIPORECE,'TIPO DE RECEBIMENTO DO MOVIMENTO DE CAIXA NO RELACIONADO');
          END IF;

       END LOOP;

    FOR TMP_IMPOSTOREDZ IN (SELECT *
                              FROM TMP_IMPOSTOREDZ
                             WHERE CDFILIAL   = TMP_TURCAIXA.CDFILIAL
                               AND CDCAIXA    = TMP_TURCAIXA.CDCAIXA
                               AND DTREDUCAOZ = TMP_TURCAIXA.DTMOVTURCAIX) LOOP
        BEGIN
            SELECT MAX(CDIMPOSTO)
              INTO V_CDIMPOSTO
              FROM IMPOSTOVENDA
             WHERE CDIMPOSTOVD = TMP_IMPOSTOREDZ.CDIMPOSTO;
        EXCEPTION
             WHEN NO_DATA_FOUND THEN
                  V_CDIMPOSTO := NULL;
        END;
        IF V_CDIMPOSTO IS NULL THEN
           INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTREDUCAOZ,DESCRICAO) VALUES (TMP_IMPOSTOREDZ.CDFILIAL,TMP_IMPOSTOREDZ.CDCAIXA,TMP_IMPOSTOREDZ.DTREDUCAOZ,'IMPOSTO "'|| TMP_IMPOSTOREDZ.CDIMPOSTO ||'" DA REDUO Z NO RELACIONADO. FAA O RELACIONAMENTO NA TELA DE "RELACIONAMENTOS PARA IMPORTAO"');
        END IF;
    END LOOP;

    FOR TMP_FORMPGTOREDZ IN (SELECT *
                               FROM TMP_FORMPGTOREDZ
                              WHERE CDFILIAL   = TMP_TURCAIXA.CDFILIAL
                                AND CDCAIXA    = TMP_TURCAIXA.CDCAIXA
                                AND DTREDUCAOZ = TMP_TURCAIXA.DTMOVTURCAIX) LOOP
        BEGIN
              SELECT MAX(CDTIPORECE)
                INTO V_CDTIPORECE
                FROM TPRECEVENDA
               WHERE CDTIPORECEVD = TMP_FORMPGTOREDZ.CDTIPORECE;
          EXCEPTION
               WHEN NO_DATA_FOUND THEN
                    V_CDTIPORECE := NULL;
          END;

          IF V_CDTIPORECE IS NULL THEN
            INSERT INTO ERROIMPORTVENDA(CDFILIAL,CDCAIXA,DTREDUCAOZ,CDTIPORECE,DESCRICAO) VALUES (V_CDFILIAL,V_CDCAIXA,TMP_FORMPGTOREDZ.DTREDUCAOZ,TMP_FORMPGTOREDZ.CDTIPORECE,'TIPO DE RECEBIMENTO DA REDUO Z NO RELACIONADO. FAA O RELACIONAMENTO NA TELA DE "RELACIONAMENTOS PARA IMPORTAO"');
          END IF;
    END LOOP;

    SELECT COUNT(*)
      INTO V_CONTAERRO
      FROM ERROIMPORTVENDA;
    IF V_CONTAERRO > 0 THEN
      DELETE TURCAIXA
       WHERE CDFILIAL = V_CDFILIAL
         AND CDCAIXA  = V_CDCAIXA
         AND TO_DATE(DTABERCAIX, 'DD/MM/YYYY HH24:MI:SS') = TO_DATE(TMP_TURCAIXA.DTABERCAIX, 'DD/MM/YYYY HH24:MI:SS');
    END IF;

    END LOOP;

    /*FIM - BUSCA E VALIDA OS RELACIONAMENTOS "DE/PARA" */

    SELECT COUNT(*)
      INTO V_CONTAERRO
      FROM ERROIMPORTVENDA;

    IF V_CONTAERRO > 0 THEN
       P_RETORNO := 'NOT';
    ELSE
       P_RETORNO := 'OK';
       V_RELAC   := 'OK';
    END IF;

    /*INICIO - INSERI AS INFORMAES NA BASE DE DADOS*/

    IF V_RELAC = 'OK' THEN

      FOR TMP_TURCAIXA IN (SELECT * FROM TMP_TURCAIXA) LOOP

         BEGIN
           SELECT CDFILIAL, CDCAIXA, CDLOJA
             INTO V_CDFILIAL, V_CDCAIXA, V_CDLOJA
             FROM CAIXAVENDA
            WHERE CDFILIALVD = TMP_TURCAIXA.CDFILIAL
              AND CDCAIXAVD  = TMP_TURCAIXA.CDCAIXA;
         EXCEPTION
              WHEN NO_DATA_FOUND THEN
                   V_CDFILIAL := NULL;
                   V_CDCAIXA  := NULL;
         END;
         IF V_EXISTE = 'N' THEN
           FOR TMP_VENDA IN (SELECT *
                               FROM TMP_VENDA
                              WHERE CDFILIALTUR = TMP_TURCAIXA.CDFILIAL
                                AND CDCAIXATUR  = TMP_TURCAIXA.CDCAIXA
                                AND DTABERTUR   = TMP_TURCAIXA.DTABERCAIX) LOOP
              BEGIN
                 SELECT MAX(CDCLIENTE)
                   INTO V_CDCLIENTE
                   FROM CLIENTEVENDA
                  WHERE CDCLIENTEVD = TMP_VENDA.CDCLIENTE;
              EXCEPTION
                   WHEN NO_DATA_FOUND THEN
                        V_CDCLIENTE := NULL;
              END;
                   INSERT INTO VENDA(NRSEQVENDA, CDFILIAL, CDCAIXA, CDCLIENTE, CDEMPRESA, CDLOJA, CDCONSUMIDOR, DTVENDA, DTENTRVENDA, DTABERTUR, NRCUPOMFIS, NRCONTCUPOMFISC, NRSERIEIMPVND, CDFILIALTUR, CDCAIXATUR, NRINSCRCONS, DSREFENDCONSVEN,IDSITUVENDA)
                        VALUES (TMP_VENDA.NRSEQVENDA, V_CDFILIAL, V_CDCAIXA, V_CDCLIENTE, P_EMPRESA, V_CDLOJA, TMP_VENDA.CDCONSUMIDOR, TO_DATE(TMP_VENDA.DTVENDA, 'DD/MM/YYYY HH24:MI:SS'), TMP_VENDA.DTENTRVENDA, TO_DATE(TMP_VENDA.DTABERTUR, 'DD/MM/YYYY HH24:MI:SS'), TMP_VENDA.NRCUPOMFIS, TMP_VENDA.NRCONTCUPOMFISC, TMP_VENDA.NRSERIEIMPVND, V_CDFILIAL, V_CDCAIXA, TMP_VENDA.NRINSCRCONS, TMP_VENDA.DSREFENDCONSVEN,'O');

              FOR TMP_ITEMVENDA IN (SELECT *
                                      FROM TMP_ITEMVENDA
                                     WHERE CDFILIAL   = TMP_VENDA.CDFILIAL
                                       AND CDCAIXA    = TMP_VENDA.CDCAIXA
                                       AND NRSEQVENDA = TMP_VENDA.NRSEQVENDA) LOOP

                 BEGIN
                    SELECT MAX(CDPRODUTO)
                      INTO V_CDPRODUTO
                      FROM PRODUTOVENDA
                     WHERE CDPRODUTOVD = TMP_ITEMVENDA.CDPRODUTO;
                 EXCEPTION
                      WHEN NO_DATA_FOUND THEN
                           V_CDPRODUTO := NULL;
                 END;

                 INSERT INTO ITEMVENDA(CDFILIAL,CDCAIXA,NRSEQVENDA,NRSEQUITVEND,QTPRODVEND,VRUNITVEND,VRUNITVENDCL,VRDESITVEND,CDPRODUTO,CDORDALIQIMPR,VRALIQIMPR,NRORDITCUPFIS,VRACRITVEND)
                      VALUES (V_CDFILIAL,V_CDCAIXA,TMP_ITEMVENDA.NRSEQVENDA,SUBSTR(TMP_ITEMVENDA.NRSEQUITVEND,8),TMP_ITEMVENDA.QTPRODVEND,TMP_ITEMVENDA.VRUNITVEND,0,TMP_ITEMVENDA.VRDESITVEND,V_CDPRODUTO,TMP_ITEMVENDA.CDORDALIQIMPR,TMP_ITEMVENDA.VRALIQIMPR,TMP_ITEMVENDA.NRORDITCUPFIS,TMP_ITEMVENDA.VRACRITVEND);

                 FOR TMP_ITVENDAIMPOS IN (SELECT *
                                            FROM TMP_ITVENDAIMPOS
                                           WHERE CDFILIAL     = TMP_ITEMVENDA.CDFILIAL
                                             AND CDCAIXA      = TMP_ITEMVENDA.CDCAIXA
                                             AND NRSEQVENDA   = TMP_ITEMVENDA.NRSEQVENDA
                                             AND NRSEQUITVEND = TMP_ITEMVENDA.NRSEQUITVEND) LOOP

                    INSERT INTO ITVENDAIMPOS(CDFILIAL,CDCAIXA, NRSEQVENDA, NRSEQUITVEND, NRSEQITIMPOS, CDIMPOSTO, VRPEALPRODIT, VRIMPOPRODIT)
                         VALUES (V_CDFILIAL,V_CDCAIXA,TMP_ITVENDAIMPOS.NRSEQVENDA,SUBSTR(TMP_ITVENDAIMPOS.NRSEQUITVEND,8),SUBSTR(TMP_ITVENDAIMPOS.NRSEQITIMPOS,8),TMP_ITVENDAIMPOS.CDIMPOSTO,TMP_ITVENDAIMPOS.VRPEALPRODIT,TMP_ITVENDAIMPOS.VRIMPOPRODIT);
                 END LOOP;
              END LOOP;

              FOR TMP_ITVENDACAN IN (SELECT *
                                       FROM TMP_ITVENDACAN
                                      WHERE CDFILIAL   = TMP_VENDA.CDFILIAL
                                        AND CDCAIXA    = TMP_VENDA.CDCAIXA
                                        AND NRSEQVENDA = TMP_VENDA.NRSEQVENDA) LOOP

                 BEGIN
                    SELECT MAX(CDPRODUTO)
                      INTO V_CDPRODUTO
                      FROM PRODUTOVENDA
                     WHERE CDPRODUTOVD = TMP_ITVENDACAN.CDPRODUTO;
                 EXCEPTION
                      WHEN NO_DATA_FOUND THEN
                           V_CDPRODUTO := NULL;
                 END;

                 INSERT INTO ITVENDACAN(CDFILIAL,CDCAIXA,NRSEQVENDA,NRSEQITVENDC,QTPRODVENDC,VRUNITVENDC,VRUNITVENCLC,VRDESITVENDC,CDPRODUTO,CDORDALIQIMPRIC,VRALIQIMPRIC,NRORDITCUPFISCA,VRACRITVENDC)
                      VALUES (V_CDFILIAL,V_CDCAIXA,TMP_ITVENDACAN.NRSEQVENDA,SUBSTR(TMP_ITVENDACAN.NRSEQUITVENDC,8),TMP_ITVENDACAN.QTPRODVENDC,TMP_ITVENDACAN.VRUNITVENDC,0,TMP_ITVENDACAN.VRDESITVENDC,V_CDPRODUTO,TMP_ITVENDACAN.CDORDALIQIMPR,TMP_ITVENDACAN.VRALIQIMPR,TMP_ITVENDACAN.NRORDITCUPFISCA,TMP_ITVENDACAN.VRACRITVENDC);
              END LOOP;
           END LOOP;

           FOR TMP_MOVCAIXA IN (SELECT *
                                  FROM TMP_MOVCAIXA
                                 WHERE CDFILIAL   = TMP_TURCAIXA.CDFILIAL
                                   AND CDCAIXA    = TMP_TURCAIXA.CDCAIXA
                                   AND DTABERCAIX = TMP_TURCAIXA.DTABERCAIX) LOOP
              BEGIN
                 SELECT MAX(CDCLIENTE)
                   INTO V_CDCLIENTE
                   FROM CLIENTEVENDA
                  WHERE CDCLIENTEVD = TMP_MOVCAIXA.CDCLIENTE;
              EXCEPTION
                   WHEN NO_DATA_FOUND THEN
                        V_CDCLIENTE := NULL;
              END;

              BEGIN
                   SELECT MAX(CDTIPORECE)
                     INTO V_CDTIPORECE
                     FROM TPRECEVENDA
                    WHERE CDTIPORECEVD = TMP_MOVCAIXA.CDTIPORECE;
              EXCEPTION
                   WHEN NO_DATA_FOUND THEN
                        V_CDTIPORECE := NULL;
              END;


              INSERT INTO MOVCAIXA (CDFILIAL,CDCAIXA,DTABERCAIX,NRSEQUMOVI,IDTIPOMOVIVE,VRMOVIVEND,NRSEQVENDA,CDTIPORECE,DTHRINCMOV,DTMOVIMCAIXA,CDCLIENTE,NRCARTBANCO,CDNSUHOSTTEF,DSMOVIVEND)
                   VALUES (V_CDFILIAL,V_CDCAIXA,TO_DATE(TMP_MOVCAIXA.DTABERCAIX, 'DD/MM/YYYY HH24:MI:SS'),TMP_MOVCAIXA.NRSEQUMOVI,TMP_MOVCAIXA.IDTIPOMOVIVE,TMP_MOVCAIXA.VRMOVIVEND,TMP_MOVCAIXA.NRSEQVENDA,V_CDTIPORECE,TMP_MOVCAIXA.DTHRINCMOV,TMP_MOVCAIXA.DTMOVIMCAIXA,V_CDCLIENTE,TMP_MOVCAIXA.NRCARTBANCO,TMP_MOVCAIXA.CDNSUHOSTTEF,TMP_MOVCAIXA.DSMOVIVEND);

           END LOOP;

           FOR TMP_REDUCAOZ IN (SELECT *
                                  FROM TMP_REDUCAOZ
                                 WHERE CDFILIAL   = TMP_TURCAIXA.CDFILIAL
                                   AND CDCAIXA    = TMP_TURCAIXA.CDCAIXA
                                   AND DTREDUCAOZ = TMP_TURCAIXA.DTMOVTURCAIX) LOOP
              INSERT INTO REDUCAOZ (CDFILIAL,CDCAIXA,NRECFREDZ,DTREDUCAOZ,NRREINIREDZ,NRREDREDZ,VRGTREDZ,VRVENBRUREDZ,VRISSREDZ,VRTOTCANREDZ,VRTOTDESREDZ,VRVENLIQREDZ,VRTOTACRREDZ,VRSTRIBREDZ,VRISENCREDZ,VRNINCIDREDZ,NRSERIEREDZ,DSMODMARCAECF,NRUSUARIOMFD,CDMFADICIONAL,DTEMISREDZ,NRPRIMCFREDZ,NRULTCFREDZ,NRCANCFREDZ)
                   VALUES (V_CDFILIAL,V_CDCAIXA,TMP_REDUCAOZ.NRECFREDZ,TMP_REDUCAOZ.DTREDUCAOZ,TMP_REDUCAOZ.NRREINIREDZ,TMP_REDUCAOZ.NRREDREDZ,TMP_REDUCAOZ.VRGTREDZ,TMP_REDUCAOZ.VRVENBRUREDZ,TMP_REDUCAOZ.VRISSREDZ,TMP_REDUCAOZ.VRTOTCANREDZ,TMP_REDUCAOZ.VRTOTDESREDZ,TMP_REDUCAOZ.VRVENLIQREDZ,TMP_REDUCAOZ.VRTOTACRREDZ,TMP_REDUCAOZ.VRSTRIBREDZ,TMP_REDUCAOZ.VRISENCREDZ,TMP_REDUCAOZ.VRNINCIDREDZ,TMP_REDUCAOZ.NRSERIEREDZ,TMP_REDUCAOZ.DSMODMARCAECF,TMP_REDUCAOZ.NRUSUARIOMFD,TMP_REDUCAOZ.CDMFADICIONAL,TMP_REDUCAOZ.DTEMISREDZ,TMP_REDUCAOZ.NRPRIMCFREDZ,TMP_REDUCAOZ.NRULTCFREDZ,TMP_REDUCAOZ.NRCANCFREDZ);



              FOR TMP_IMPOSTOREDZ IN (SELECT *
                                        FROM TMP_IMPOSTOREDZ
                                       WHERE CDFILIAL   = TMP_REDUCAOZ.CDFILIAL
                                         AND CDCAIXA    = TMP_REDUCAOZ.CDCAIXA
                                         AND NRECFREDZ  = TMP_REDUCAOZ.NRECFREDZ
                                         AND DTREDUCAOZ = TMP_REDUCAOZ.DTREDUCAOZ) LOOP

                 BEGIN
                     SELECT MAX(CDIMPOSTO)
                       INTO V_CDIMPOSTO
                       FROM IMPOSTOVENDA
                      WHERE CDIMPOSTOVD = TMP_IMPOSTOREDZ.CDIMPOSTO;
                 EXCEPTION
                      WHEN NO_DATA_FOUND THEN
                           V_CDIMPOSTO := NULL;
                 END;

                 INSERT INTO IMPOSTOREDZ (CDFILIAL,CDCAIXA,NRECFREDZ,DTREDUCAOZ,CDIMPOSTO,VRALIQIMPRZ,VRBCALCIMPRZ,VRIMPOSTORZ,NRSEQALIQIMPRZ)
                      VALUES (V_CDFILIAL,V_CDCAIXA,TMP_IMPOSTOREDZ.NRECFREDZ,TMP_IMPOSTOREDZ.DTREDUCAOZ,V_CDIMPOSTO,TMP_IMPOSTOREDZ.VRALIQIMPRZ,TMP_IMPOSTOREDZ.VRBCALCIMPRZ,TMP_IMPOSTOREDZ.VRIMPOSTORZ,TMP_IMPOSTOREDZ.NRSEQALIQIMPRZ);
              END LOOP;

              FOR TMP_FORMPGTOREDZ IN (SELECT *
                                         FROM TMP_FORMPGTOREDZ
                                        WHERE CDFILIAL   = TMP_REDUCAOZ.CDFILIAL
                                          AND CDCAIXA    = TMP_REDUCAOZ.CDCAIXA
                                          AND NRECFREDZ  = TMP_REDUCAOZ.NRECFREDZ
                                          AND DTREDUCAOZ = TMP_REDUCAOZ.DTREDUCAOZ) LOOP
                 BEGIN
                     SELECT MAX(CDTIPORECE)
                       INTO V_CDTIPORECE
                       FROM TPRECEVENDA
                      WHERE CDTIPORECEVD = TMP_FORMPGTOREDZ.CDTIPORECE;
                 EXCEPTION
                      WHEN NO_DATA_FOUND THEN
                           V_CDTIPORECE := NULL;
                 END;

                 INSERT INTO FORMPGTOREDZ (CDFILIAL,CDCAIXA,NRECFREDZ,DTREDUCAOZ,CDTIPORECE,VRFORMPGTORZ)
                      VALUES (V_CDFILIAL,V_CDCAIXA,TMP_FORMPGTOREDZ.NRECFREDZ,TMP_FORMPGTOREDZ.DTREDUCAOZ,V_CDTIPORECE,TMP_FORMPGTOREDZ.VRFORMPGTORZ);
              END LOOP;
           END LOOP;

         ELSE
            FOR TMP_TURCAIXA IN (SELECT * FROM TMP_TURCAIXA WHERE STATUS = 'S') LOOP
               INSERT INTO ERROIMPORTVENDA (CDFILIAL,CDCAIXA,DTABERCAIX,DESCRICAO) VALUES (TMP_TURCAIXA.CDFILIAL,TMP_TURCAIXA.CDCAIXA,TMP_TURCAIXA.DTABERCAIX,'INFORMAES J EXISTENTES NA BASE DE DADOS');
               P_RETORNO := 'NOT';
            END LOOP;
         END IF;
      END LOOP;
    END IF;
    /*FIM - INSERI AS INFORMAES NA BASE DE DADOS*/
  END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('VD_IMPORTACAO_VENDA','5.85.000'); END;
/