IF EXISTS (SELECT
              *
           FROM
              SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'ARQDIGITAL_BLOCOD' AND
              TYPE   = 'P' 		   AND
              U.UID  = O.UID               AND
              U.NAME = USER)

DROP PROCEDURE ARQDIGITAL_BLOCOD  
GO

CREATE PROCEDURE ARQDIGITAL_BLOCOD
   @P_CDIMPOSTO    VARCHAR(02),
   @P_CDEMPRESA    VARCHAR(02),
   @P_CDINSCESTA   VARCHAR(14),
   @P_DTINICIAL    DATETIME,
   @P_DTFINAL      DATETIME,
   @P_NRSEQARQMAG  VARCHAR(20), 
   @P_RETURN       NUMERIC OUTPUT
AS

DECLARE @V_CONTREGD    NUMERIC;
DECLARE @V_MOVIMENT    NUMERIC;

DECLARE @C_ARQ_D020     VARCHAR(20);
DECLARE @C_ARQ_D030     VARCHAR(20);
DECLARE @C_ARQ_D040     VARCHAR(20);
DECLARE @C_ARQ_D050     VARCHAR(20);
DECLARE @C_ARQ_D400     VARCHAR(20);
DECLARE @C_ARQ_D450     VARCHAR(20);
DECLARE @C_ARQ_D460     VARCHAR(20); 

DECLARE @C_ARQ20_CDFILIAL     VARCHAR(20); 
DECLARE @C_ARQ20_NRLANCTONF   VARCHAR(20);  
DECLARE @C_ARQ20_CDMODDOCFISC VARCHAR(20); 
DECLARE @C_ARQ20_IDENTRSAIDOP VARCHAR(20);  
DECLARE @C_ARQ20_IDORIGDESTNF VARCHAR(20);  
DECLARE @C_ARQ20_CDFORNECED   VARCHAR(20); 
DECLARE @C_ARQ20_CDCLIENTE    VARCHAR(20); 
DECLARE @C_ARQ20_NRPLACAVEIC  VARCHAR(20); 
DECLARE @C_ARQ20_SGUFVEIC     VARCHAR(20); 
DECLARE @C_ARQ20_IDPGTOFRETE  VARCHAR(20); 
DECLARE @C020_CDFILIAL        VARCHAR(20); 
DECLARE @C020_NRLANCTONF      VARCHAR(20); 
DECLARE @C020_CDMODDOCFISC    VARCHAR(20); 
DECLARE @C020_IDENTRSAIDOP    VARCHAR(20); 
DECLARE @C020_IDORIGDESTNF    VARCHAR(20); 
DECLARE @C020_CDFORNECED      VARCHAR(20);  
DECLARE @C020_CDCLIENTE       VARCHAR(20); 
DECLARE @C020_NRPLACAVEIC     VARCHAR(20); 
DECLARE @C020_SGUFVEIC        VARCHAR(20); 
DECLARE @C020_IDPGTOFRETE     VARCHAR(20); 
DECLARE @C400_CDFILIAL        VARCHAR(20); 
DECLARE @C400_NRLANCTONF      VARCHAR(20); 
DECLARE @C400_CDMODDOCFISC    VARCHAR(20); 

BEGIN

   DECLARE C_REGD020 CURSOR FOR (SELECT ('|D020' + '|' +
                             '0'                 + '|' +  /* aquisio */
                             '0'                 + '|' +  /* emisso prpria */
                             ISNULL(FO.CDFORNECED, '')       + '|' +
                             ISNULL(N.CDMODDOCFISC, '')      + '|' +
                             CASE N.IDSTATUS     WHEN 'C' THEN '02'           ELSE '00'      END+ '|' + /* situao do documento */
                             CASE N.IDENTRSAIDOP WHEN 'E' THEN  N.CDSERIEENTR ELSE N.CDSERIE END+ '|' +
                             '' 		 + '|' + /* sub serie */
                             ISNULL(N.NRNOTAFISC, '')        + '|' +
                             ISNULL(REPLACE(CONVERT(VARCHAR,N.DTEMISSAO), '/', ''), '') + '|' +
                             ISNULL(REPLACE(CONVERT(VARCHAR,N.DTENTRSAID), '/', ''), '')+ '|' + /* data da aquisio */
                             ISNULL(C.CDFISCOPER, '')  + '|' + /* cdigo da natureza da prestao */
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRNOTAFISC))), '.', ','),'0,00')  + '|' +    /* valor total do documento */
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'D', NULL)))), '.', ','), '')+ '|' + /* valor total do desconto */
                             ISNULL(N.IDPGTOFRETE, '') + '|' + /* indicador de tipo de frete */
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRPRODUTOS))), '.', ','),'0,00')  + '|' +       /* valor total prestao de servios */
                             ISNULL(I.CDSITUTRIBNF, '')+ '|' +
                             ISNULL(I.CDFISCOPERNF, '')+ '|' +
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),I.VRBASECALCNF))), '.', ','),'0,00')+ '|' +
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),I.VRALIQNF))),     '.', ','),'0,00')+ '|' +
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),I.VRIMPOSTONF))),  '.', ','),'0,00')+ '|' +
                             '' + '|' ) ARQ_D020,

                             N.CDFILIAL, N.NRLANCTONF, N.CDMODDOCFISC, N.IDENTRSAIDOP, N.IDORIGDESTNF, N.CDFORNECED,
                             N.CDCLIENTE, N.NRPLACAVEIC, N.SGUFVEIC, N.IDPGTOFRETE

                     FROM MAPAAPURAC M,  NOTAFISCAL N, IMPOSTONF I,
                          FORNECEDOR FO, CODFISCOPER C

                     WHERE M.CDEMPRESA       = @P_CDEMPRESA                       AND
                           M.CDINSCESTA      = @P_CDINSCESTA                      AND
                           M.DTINIPERIODO    = @P_DTINICIAL                       AND
                           M.DTFIMPERIODO    = @P_DTFINAL                         AND
                           M.CDIMPOSTO       = @P_CDIMPOSTO                       AND
                           I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU                     AND
                           I.CDIMPOSTO       = @P_CDIMPOSTO                       AND
                           N.CDMODDOCFISC    IN ('07','08','09','10','11','26')   AND
                           N.CDFILIAL        = I.CDFILIAL                         AND
                           N.NRLANCTONF      = I.NRLANCTONF                       AND
                           N.CDFORNECED      = FO.CDFORNECED                      AND
                           N.CDMODDOCFISC    = C.CDMODDOCFISC                     AND
                           N.IDORIGDESTNF    = 'F'                                AND
                           ((N.IDSTATUS='A') OR (N.IDSTATUS='E'))                 AND
                           ISNULL(I.IDIMPOSTONF, '1') <> '3'                      AND
                           ((ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') = '1') OR (ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') = '5'))

                     UNION ALL

                     SELECT ('|D020'         + '|' +
                             '0'             + '|' +  /* aquisio */
                             '0'             + '|' +  /* emisso prpria */
                             ISNULL(CL.CDCLIENTE, '')    + '|' +
                             ISNULL(N.CDMODDOCFISC, '')  + '|' +
                             CASE N.IDSTATUS WHEN 'C' THEN '02' ELSE '00' END+ '|' + /* situao do documento */
                             CASE N.IDENTRSAIDOP WHEN 'E' THEN N.CDSERIEENTR ELSE N.CDSERIE END+ '|' +
                             ''+ '|' + /* sub serie */
                             ISNULL(N.NRNOTAFISC, '') + '|' +
                             ISNULL(REPLACE(CONVERT(VARCHAR,N.DTEMISSAO),'/', ''), '')+ '|' +
                             ISNULL(REPLACE(CONVERT(VARCHAR,N.DTENTRSAID), '/', ''), '') + '|' + /* data da aquisio */
                             ISNULL(C.CDFISCOPER, '') + '|' + /* cdigo da natureza da prestao */
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRNOTAFISC))), '.', ','),'0,00')+ '|' +    /* valor total do documento */
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'D', NULL)))), '.', ','), '')+ '|' + /* valor total do desconto */
                             ISNULL(N.IDPGTOFRETE, '')     + '|' + /* indicador de tipo de frete */
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRPRODUTOS))), '.', ','),'0,00')+ '|' +       /* valor total prestao de servios */
                             ISNULL(I.CDSITUTRIBNF, '')  + '|' +
                             ISNULL(I.CDFISCOPERNF, '')  + '|' +
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),I.VRBASECALCNF))), '.', ','),'0,00')+ '|' +
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),I.VRALIQNF))),     '.', ','),'0,00')+ '|' +
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),I.VRIMPOSTONF))),  '.', ','),'0,00')+ '|' +
                             ''  + '|') AS ARQ_D020,

                             N.CDFILIAL, N.NRLANCTONF, N.CDMODDOCFISC, N.IDENTRSAIDOP, N.IDORIGDESTNF, N.CDFORNECED,
                             N.CDCLIENTE, N.NRPLACAVEIC, N.SGUFVEIC, N.IDPGTOFRETE

                     FROM MAPAAPURAC M,  NOTAFISCAL N, IMPOSTONF I,
                          CLIENTE CL, CODFISCOPER C

                     WHERE M.CDEMPRESA       = @P_CDEMPRESA                      AND
                           M.CDINSCESTA      = @P_CDINSCESTA                     AND
                           M.DTINIPERIODO    = @P_DTINICIAL                      AND
                           M.DTFIMPERIODO    = @P_DTFINAL                        AND
                           M.CDIMPOSTO       = @P_CDIMPOSTO                      AND
                           I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU                    AND
                           I.CDIMPOSTO       = @P_CDIMPOSTO                      AND
                           N.CDMODDOCFISC    IN ('07','08','09','10','11','26')  AND
                           N.CDFILIAL        = I.CDFILIAL                        AND
                           N.NRLANCTONF      = I.NRLANCTONF                      AND
                           N.CDCLIENTE       = CL.CDCLIENTE                      AND
                           N.CDMODDOCFISC    = C.CDMODDOCFISC                    AND
                           N.IDORIGDESTNF    = 'C'                               AND
                           ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))            AND
                           ISNULL(I.IDIMPOSTONF, '1') <> '3'                     AND
                           ((ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') = '1') OR (ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') = '5'))

                     UNION ALL

                     SELECT ('|D020'        + '|' +
                             '0'            + '|' +  /* aquisio */
                             '0'            + '|' +  /* emisso prpria */
                             ISNULL(FI.CDFILIAL, '')    + '|' +
                             ISNULL(N.CDMODDOCFISC, '') + '|' +
                             CASE N.IDSTATUS     WHEN 'C' THEN '02'          ELSE '00'      END + '|' + /* situao do documento */
                             CASE N.IDENTRSAIDOP WHEN 'E' THEN N.CDSERIEENTR ELSE N.CDSERIE END + '|' +
                             '' + '|' + /* sub serie */
                             ISNULL(N.NRNOTAFISC, '')   + '|' +
                             ISNULL(REPLACE(CONVERT(VARCHAR,N.DTEMISSAO), '/', ''), '') + '|' +
                             ISNULL(REPLACE(CONVERT(VARCHAR,N.DTENTRSAID),'/', ''), '') + '|' + /* data da aquisio */
                             ISNULL(C.CDFISCOPER, '')   + '|' + /* cdigo da natureza da prestao */
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2), N.VRNOTAFISC))), '.', ','),'0,00') + '|' +    /* valor total do documento */
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'D',NULL)))), '.', ','), '') + '|' + /* valor total do desconto */
                             ISNULL(N.IDPGTOFRETE, '')  + '|' + /* indicador de tipo de frete */
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRPRODUTOS))),  '.', ','),'0,00') + '|' +       /* valor total prestao de servios */
                             ISNULL(I.CDSITUTRIBNF, '') + '|' +
                             ISNULL(I.CDFISCOPERNF, '') + '|' +
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),I.VRBASECALCNF))),'.', ','),'0,00') + '|' +
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),I.VRALIQNF))),    '.', ','),'0,00') + '|' +
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),I.VRIMPOSTONF))), '.', ','),'0,00') + '|' +
                             '' + '|') AS ARQ_D020,
                             N.CDFILIAL, N.NRLANCTONF, N.CDMODDOCFISC, N.IDENTRSAIDOP, N.IDORIGDESTNF, N.CDFORNECED,
                             N.CDCLIENTE, N.NRPLACAVEIC, N.SGUFVEIC, N.IDPGTOFRETE

                     FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I,
                          FILIAL FI, CODFISCOPER C

                     WHERE M.CDEMPRESA       = @P_CDEMPRESA                     AND
                           M.CDINSCESTA      = @P_CDINSCESTA                    AND
                           M.DTINIPERIODO    = @P_DTINICIAL                     AND
                           M.DTFIMPERIODO    = @P_DTFINAL                       AND
                           M.CDIMPOSTO       = @P_CDIMPOSTO                     AND
                           I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU                   AND
                           I.CDIMPOSTO       = @P_CDIMPOSTO                     AND
                           N.CDMODDOCFISC    IN ('07','08','09','10','11','26') AND
                           N.CDFILIAL        = I.CDFILIAL                       AND
                           N.NRLANCTONF      = I.NRLANCTONF                     AND
                           N.CDFILIAL        = FI.CDFILIAL                      AND
                           N.CDMODDOCFISC    = C.CDMODDOCFISC                   AND
                           N.IDORIGDESTNF    = 'L'                              AND
                           ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))           AND
                           ISNULL(I.IDIMPOSTONF, '1') <> '3'                    AND
                           ((ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') = '1') OR (ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') = '5'))) --LOOP
     

      OPEN C_REGD020;
      FETCH NEXT FROM C_REGD020 INTO @C_ARQ_D020, @C020_CDFILIAL, @C020_NRLANCTONF, @C020_CDMODDOCFISC,
                                     @C020_IDENTRSAIDOP, @C020_IDORIGDESTNF, @C020_CDFORNECED,
                                     @C020_CDCLIENTE, @C020_NRPLACAVEIC, @C020_SGUFVEIC, @C020_IDPGTOFRETE

      WHILE (@@FETCH_STATUS = 0) BEGIN

        INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('25'+RIGHT(REPLICATE('0', 8)+ RTRIM(@V_CONTREGD), 8), @C_ARQ_D020, @P_NRSEQARQMAG);
         SET @V_CONTREGD =  ISNULL(@V_CONTREGD,0) + 1;

      DECLARE C_REGD030 CURSOR FOR (SELECT ('|D030'+ '|' +
                                ISNULL(MU.CDMUNICIBGE, '')     + '|' +
                                ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.ORIGEM_NOTA(@C_ARQ20_CDFILIAL, @C_ARQ20_NRLANCTONF, 'I')))), '.', ','),'0,00')+ '|' +
                                ISNULL(@C_ARQ20_NRPLACAVEIC, '') + '|' + /* placa do veculo */
                                ISNULL(@C_ARQ20_SGUFVEIC, '')    + '|' ) AS ARQ_D030 /* estado do veculo */

                        FROM IMPOSTONF I, FORNECEDOR FO, ENDEFORN EF, MUNICIPIO MU
                        WHERE @C_ARQ20_CDMODDOCFISC = '07'                              AND
                              @C_ARQ20_CDFILIAL     = I.CDFILIAL                        AND
                              @C_ARQ20_NRLANCTONF   = I.NRLANCTONF                      AND
                              @C_ARQ20_IDENTRSAIDOP = 'E'                               AND
                              @C_ARQ20_IDORIGDESTNF = 'F'                               AND
                              @C_ARQ20_CDFORNECED   = FO.CDFORNECED                     AND
                              EF.CDPAIS              = MU.CDPAIS                        AND
                              EF.SGESTADO            = MU.SGESTADO                      AND
                              EF.CDMUNICIPIO         = MU.CDMUNICIPIO

                        UNION ALL

                        SELECT ('|D030' + '|' +
                                ISNULL(MU.CDMUNICIBGE, '') + '|' +
                                ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.ORIGEM_NOTA(@C_ARQ20_CDFILIAL, @C_ARQ20_NRLANCTONF, 'I')))), '.', ','),'0,00')+ '|' +
                                ISNULL(@C_ARQ20_NRPLACAVEIC, '') + '|' + /* placa do veculo */
                                ISNULL(@C_ARQ20_SGUFVEIC, '')  + '|' ) AS ARQ_D030/* estado do veculo */

                        FROM IMPOSTONF I, CLIENTE CL, ENDECLIE EC, MUNICIPIO MU
                        WHERE C_REGD020.CDMODDOCFISC = '07'                              AND
                              C_REGD020.CDFILIAL     = I.CDFILIAL                        AND
                              C_REGD020.NRLANCTONF   = I.NRLANCTONF                      AND
                              C_REGD020.IDENTRSAIDOP = 'S'                               AND
                              C_REGD020.CDCLIENTE    = CL.CDCLIENTE                      AND
                              EC.CDPAIS              = MU.CDPAIS                         AND
                              EC.SGESTADO            = MU.SGESTADO                       AND
                              EC.CDMUNICIPIO         = MU.CDMUNICIPIO  ) 
      OPEN C_REGD030;
      FETCH NEXT FROM C_REGD030 INTO @C_ARQ_D030;

      WHILE (@@FETCH_STATUS = 0) BEGIN

        INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('25'+RIGHT(REPLICATE('0', 8)+ RTRIM(@V_CONTREGD), 8), @C_ARQ_D030, @P_NRSEQARQMAG);
         SET @V_CONTREGD =  ISNULL(@V_CONTREGD,0) + 1;

         FETCH NEXT FROM C_REGD030 INTO @C_ARQ_D030;

      END;
      CLOSE C_REGD030;
      DEALLOCATE C_REGD030;

      DECLARE C_REGD040 CURSOR FOR (SELECT ('|D040'       + '|' +
                                ISNULL(I.NRSEQITPROD, '')		  + '|' +
                                ISNULL(PR.CDPRODUTO, '') 		  + '|' +
                                ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.VALOR_ENCARGO(NF.CDFILIAL, NF.NRLANCTONF, 'A', FRETE.CDENCARGO)))), '.', ','), '') + '|' +  /* valor do frete */
                                ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.VALOR_ENCARGO(NF.CDFILIAL, NF.NRLANCTONF, 'A', OUTROS.CDENCARGO)))), '.', ','), '') + '|' + /* valor de outros valores */
                                ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),I.VRTOTAITEM))), '.', ','), '') + '|'  ) AS ARQ_D040 /* valor de outros valores */
                        FROM ITEMPRODUTO I, PRODUTO PR,

                             (SELECT CDENCARGO, IDENCARGODOS
                              FROM RELACENCARGO
                              WHERE IDENCARGODOS = 'FRET') FRETE,

                             (SELECT CDENCARGO, IDENCARGODOS
                              FROM RELACENCARGO
                              WHERE IDENCARGODOS = 'OUTR') OUTROS,

                             (SELECT I.CDFILIAL, I.NRLANCTONF
                              FROM MAPAAPURAC M, IMPOSTONF I
                              WHERE @C_ARQ20_CDMODDOCFISC = '07'           AND
                                    @C_ARQ20_CDFILIAL     = I.CDFILIAL     AND
                                    @C_ARQ20_NRLANCTONF   = I.NRLANCTONF   AND
                                    ISNULL(I.IDIMPOSTONF, '1') <> '3' )  NF
                        WHERE NF.CDFILIAL   = I.CDFILIAL                    AND
                              NF.NRLANCTONF = I.NRLANCTONF                  AND
                              I.CDPRODUTO   = PR.CDPRODUTO   ) 

      OPEN C_REGD040;
      FETCH NEXT FROM C_REGD040 INTO @C_ARQ_D040;

      WHILE (@@FETCH_STATUS = 0) BEGIN

        INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('25'+RIGHT(REPLICATE('0', 8)+ RTRIM(@V_CONTREGD), 8), @C_ARQ_D040, @P_NRSEQARQMAG);
         SET @V_CONTREGD =  ISNULL(@V_CONTREGD,0) + 1;

         FETCH NEXT FROM C_REGD040 INTO @C_ARQ_D040;

      END;
      CLOSE C_REGD040;
      DEALLOCATE C_REGD040;


      DECLARE C_REGD050 CURSOR FOR (SELECT ('|D050'                + '|' +
                                ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.ORIGEM_NOTA(@C_ARQ20_CDFILIAL, @C_ARQ20_NRLANCTONF, 'I')))), '.', ','), '')+ '|' +
                                ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.ORIGEM_NOTA(@C_ARQ20_CDFILIAL, @C_ARQ20_NRLANCTONF, 'I')))), '.', ','), '')+ '|' +
                                ''                     + '|' + /* participante consignatrio */
                                ''                     + '|' + /* participante redespachante */
                                ISNULL(@C_ARQ20_IDPGTOFRETE, '')  + '|' + /* indicador de tipo de frete */
                                ISNULL(@C_ARQ20_NRPLACAVEIC, '')  + '|' + /* placa do veculo */
                                ISNULL(@C_ARQ20_SGUFVEIC, '')     + '|' + /* estado do veculo */
                                ''                     + '|' + /* marca */
                                ''                     + '|' + /* modelo */
                                ''                     + '|' + /* ano */
                                0.00+ '|' + /* valor frete por peso */
                                0.00+ '|' + /* valor sec/cat */
                                0.00+ '|' + /* valor de despacho */
                                0.00+ '|' + /* valor pedgio */
                                0.00+ '|' + /* outros valores */
                                0.00+ '|'  ) AS ARQ_D050 /* valor total do frete */
                         FROM MAPAAPURAC M,  NOTAFISCAL N, IMPOSTONF I,
                              FORNECEDOR FO
                         WHERE @C_ARQ20_CDMODDOCFISC    = '08'                  AND
                               @C_ARQ20_CDFILIAL        = I.CDFILIAL            AND
                               @C_ARQ20_NRLANCTONF      = I.NRLANCTONF          AND
                               @C_ARQ20_CDFORNECED      = FO.CDFORNECED         AND
                               @C_ARQ20_IDORIGDESTNF    = 'F'                   AND
                               ISNULL(I.IDIMPOSTONF, '1') <> '3'                 AND
                               ((ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') = '1') OR (ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') = '5'))
                         UNION ALL
                         SELECT ('|D050'+ '|' +
                                 ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.ORIGEM_NOTA(C_REGD020.CDFILIAL, C_REGD020.NRLANCTONF, 'I')))), '.', ','), '')+ '|' +
                                 ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.ORIGEM_NOTA(C_REGD020.CDFILIAL, C_REGD020.NRLANCTONF, 'I')))), '.', ','), '')+ '|' +
                                 ''+ '|' + /* participante consignatrio */
                                 ''+ '|' + /* participante redespachante */
                                 ISNULL(C_REGD020.IDPGTOFRETE, '')+ '|' + /* indicador de tipo de frete */
                                 ISNULL(C_REGD020.NRPLACAVEIC, '')+ '|' + /* placa do veculo */
                                 ISNULL(C_REGD020.SGUFVEIC, '')+ '|' + /* estado do veculo */
                                 ''+ '|' + /* marca */
                                 ''+ '|' + /* modelo */
                                 ''+ '|' + /* ano */
                                 0.00+ '|' + /* valor frete por peso */
                                 0.00+ '|' + /* valor sec/cat */
                                 0.00+ '|' + /* valor de despacho */
                                 0.00+ '|' + /* valor pedgio */
                                 0.00+ '|' + /* outros valores */
                                 0.00+ '|'  ) AS ARQ_D050 /* valor total do frete */
                         FROM MAPAAPURAC M, IMPOSTONF I, CLIENTE CL
                         WHERE C_REGD020.CDMODDOCFISC    = '08'                  AND
                               C_REGD020.CDFILIAL        = I.CDFILIAL            AND
                               C_REGD020.NRLANCTONF      = I.NRLANCTONF          AND
                               C_REGD020.CDCLIENTE       = CL.CDCLIENTE          AND
                               C_REGD020.IDORIGDESTNF    = 'C'                   AND
                               ISNULL(I.IDIMPOSTONF, '1') <> '3'                 AND
                               ((ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') = '1') OR (ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') = '5'))
                         UNION ALL
                         SELECT ('|D050'          + '|' +
                                 ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.ORIGEM_NOTA(C_REGD020.CDFILIAL, C_REGD020.NRLANCTONF, 'I')))), '.', ','), '')+ '|' +
                                 ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.ORIGEM_NOTA(C_REGD020.CDFILIAL, C_REGD020.NRLANCTONF, 'I')))), '.', ','), '')+ '|' +
                                 ''               + '|' + /* participante consignatrio */
                                 ''               + '|' + /* participante redespachante */
                                 ISNULL(C_REGD020.IDPGTOFRETE, '')    + '|' + /* indicador de tipo de frete */
                                 ISNULL(C_REGD020.NRPLACAVEIC, '')    + '|' + /* placa do veculo */
                                 ISNULL(C_REGD020.SGUFVEIC, '')       + '|' + /* estado do veculo */
                                 ''               + '|' + /* marca */
                                 ''               + '|' + /* modelo */
                                 ''               + '|' + /* ano */
                                 0.00             + '|' + /* valor frete por peso */
                                 0.00             + '|' + /* valor sec/cat */
                                 0.00             + '|' + /* valor de despacho */
                                 0.00             + '|' + /* valor pedgio */
                                 0.00             + '|' + /* outros valores */
                                 0.00             + '|'  )  AS ARQ_D050 /* valor total do frete */
                         FROM MAPAAPURAC M,  NOTAFISCAL N, IMPOSTONF I,
                              FILIAL FI
                         WHERE C_REGD020.CDMODDOCFISC    = '08'                   AND
                               C_REGD020.CDFILIAL        = I.CDFILIAL             AND
                               C_REGD020.NRLANCTONF      = I.NRLANCTONF           AND
                               C_REGD020.CDFILIAL        = FI.CDFILIAL            AND
                               C_REGD020.IDORIGDESTNF    = 'L'                    AND
                               ISNULL(I.IDIMPOSTONF, '1') <> '3'                  AND
                               ((ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') = '1') OR (ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') = '5'))) --LOOP

      OPEN C_REGD050;
      FETCH NEXT FROM C_REGD050 INTO @C_ARQ_D050;

      WHILE (@@FETCH_STATUS = 0) BEGIN

        INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('25'+RIGHT(REPLICATE('0', 8)+ RTRIM(@V_CONTREGD), 8), @C_ARQ_D050, @P_NRSEQARQMAG);
         SET @V_CONTREGD =  ISNULL(@V_CONTREGD,0) + 1;

         FETCH NEXT FROM C_REGD050 INTO @C_ARQ_D050;

      END;
      CLOSE C_REGD050;
      DEALLOCATE C_REGD050;

     FETCH NEXT FROM C_REGD020 INTO @C_ARQ_D020, @C020_CDFILIAL, @C020_NRLANCTONF, @C020_CDMODDOCFISC,
                                    @C020_IDENTRSAIDOP, @C020_IDORIGDESTNF, @C020_CDFORNECED,
                                    @C020_CDCLIENTE, @C020_NRPLACAVEIC, @C020_SGUFVEIC, @C020_IDPGTOFRETE
   END;
   CLOSE C_REGD020;
   DEALLOCATE C_REGD020;

   DECLARE C_REGD400 CURSOR FOR (SELECT ('|D400'         + '|' +
                             '0'                         + '|' +
                             '0'                         + '|' +
                             ISNULL(N.CDFORNECED, '')                + '|' +
                             ISNULL(N.CDMODDOCFISC, '')              + '|' +
                             CASE N.IDSTATUS WHEN 'C' THEN '02' ELSE '00' END  			         			    + '|' + /* situao da nota fiscal */
                             CASE N.IDENTRSAIDOP WHEN 'E' THEN N.CDSERIEENTR ELSE N.CDSERIE END         			    + '|' +
                             ''                                  					       	       	            + '|' + /* sub serie */
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.VALOR_MAOIR_NF(N.VRNOTAFISC)))), '.', ','), '') + '|' +
                             ISNULL(N.NRNOTAFISC, '')                     						       	       	            + '|' +
                         --   REPLACE(CONVERT(VARCHAR,N.DTEMISSAO,  '103'), '/', '') 	       	       	       	       	       	    + '|' +
                         --   REPLACE(CONVERT(VARCHAR,N.DTENTRSAID, '103'), '/', '')  						    + '|' +
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRNOTAFISC))), '.', ','),'0,00')          + '|' + /* valor total do documento */
                             ISNULL(C.CDFISCOPER, '')                  				       					    + '|' + /* cdigo da natureza da prestao */
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'D', NULL)))), '.', ','), '') + '|' + /* valor total do desconto */
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRPRODUTOS))), '.', ','),'0,00')          + '|' + /* valor total prestao de servios */
                             '0.00'  												    + '|' + /* valor dos servioes no tributados */
                             '0.00' 												    + '|' + /* valor de terceiros */
                             REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'D', DESCNF.IDENCARGODOS)))), '.', ',')    + '|' +
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),I.VRBASECALCNF))), '.', ','),'0,00')	    + '|' +
                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),I.VRIMPOSTONF))), '.', ','),'0,00')         + '|' +
                             '' + '|') AS ARQ_D400,
                             N.CDFILIAL, N.NRLANCTONF, N.CDMODDOCFISC
                      FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I,
                           FORNECEDOR FO, CODFISCOPER C,
                           (SELECT E.CDENCARGO, E.IDENCARGODOS
                            FROM RELACENCARGO E
                            WHERE E.IDENCARGODOS LIKE '%DESC%')DESCNF

                      WHERE M.CDEMPRESA       = @P_CDEMPRESA                  AND
                            M.CDINSCESTA      = @P_CDINSCESTA                 AND
                            M.DTINIPERIODO    = @P_DTINICIAL                  AND
                            M.DTFIMPERIODO    = @P_DTFINAL                    AND
                            M.CDIMPOSTO       = @P_CDIMPOSTO                  AND
                            I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU                AND
                            I.CDIMPOSTO       = @P_CDIMPOSTO                  AND
                            N.CDMODDOCFISC    IN ('21','22')                  AND
                            N.CDFILIAL        = I.CDFILIAL                    AND
                            N.NRLANCTONF      = I.NRLANCTONF                  AND
                            N.CDMODDOCFISC    = C.CDMODDOCFISC                AND
                            N.CDFORNECED  = FO.CDFORNECED                     AND
                            ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))        AND
                            ISNULL(I.IDIMPOSTONF, '1') <> '3'                 AND
                            ((ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') = '1') OR (ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') = '5'))

                      UNION ALL
                      SELECT ('|D400'          + '|' +
                              '0'              + '|' +
                              '0'              + '|' +
                              ISNULL(N.CDCLIENTE, '')      + '|' +
                              ISNULL(N.CDMODDOCFISC, '')   + '|' +
                              CASE N.IDSTATUS WHEN 'C' THEN '02' ELSE '00' END + '|' + /* situao da nota fiscal */
                              CASE N.IDENTRSAIDOP WHEN 'E' THEN N.CDSERIEENTR ELSE N.CDSERIE END+ '|' +
                              ''                                  + '|' + /* sub serie */
                              ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.VALOR_MAOIR_NF(N.VRNOTAFISC) ))), '.', ','), '') + '|' +        /* classe de consumo */
                              ISNULL(N.NRNOTAFISC, '')                        + '|' +
                         --     REPLACE(CONVERT(VARCHAR,N.DTEMISSAO,  '103'), '/', '')    + '|' +
                         --     REPLACE(CONVERT(VARCHAR,N.DTENTRSAID, '103'), '/', '')    + '|' +
                              ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRNOTAFISC))), '.', ','),'0,00')+ '|' +       /* valor total do documento */
                              ISNULL(C.CDFISCOPER, '')                        + '|' + /* cdigo da natureza da prestao */
                              REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'D', NULL)))), '.', ',')+ '|' + /* valor total do desconto */
                              ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRPRODUTOS))), '.', ','),'0,00')+ '|' +       /* valor total prestao de servios */
                              '0.00'  + '|' +  /* valor dos servioes no tributados */
                              '0.00'  + '|' +  /* valor de terceiros */
                              ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'D', DESCNF.IDENCARGODOS)))), '.', ','),'0,00') + '|' +
                              ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),I.VRBASECALCNF))), '.', ','),'0,00')+ '|' +
                              ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),I.VRIMPOSTONF))), '.', ','),'0,00')+ '|' +
                              '' + '|') AS ARQ_D400,
                              N.CDFILIAL, N.NRLANCTONF, N.CDMODDOCFISC

                      FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I,
                           CLIENTE CL, CODFISCOPER C,

                           (SELECT E.CDENCARGO, E.IDENCARGODOS
                            FROM RELACENCARGO E
                            WHERE E.IDENCARGODOS LIKE '%DESC%') DESCNF

                      WHERE M.CDEMPRESA       = @P_CDEMPRESA                  AND
                            M.CDINSCESTA      = @P_CDINSCESTA                 AND
                            M.DTINIPERIODO    = @P_DTINICIAL                  AND
                            M.DTFIMPERIODO    = @P_DTFINAL                    AND
                            M.CDIMPOSTO       = @P_CDIMPOSTO                  AND
                            I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU                AND
                            I.CDIMPOSTO       = @P_CDIMPOSTO                  AND
                            N.CDMODDOCFISC    IN ('21','22')                  AND
                            N.CDFILIAL        = I.CDFILIAL                    AND
                            N.NRLANCTONF      = I.NRLANCTONF                  AND
                            N.CDMODDOCFISC    = C.CDMODDOCFISC                AND
                            N.CDCLIENTE       = CL.CDCLIENTE                  AND
                            ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))        AND
                            ISNULL(I.IDIMPOSTONF, '1') <> '3'                 AND
                            ((ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') = '1') OR (ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') = '5')))
      OPEN C_REGD400;
      FETCH NEXT FROM C_REGD400 INTO @C_ARQ_D400, @C400_CDFILIAL, @C400_NRLANCTONF, @C400_CDMODDOCFISC

      WHILE (@@FETCH_STATUS = 0) BEGIN

         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('26'+RIGHT(REPLICATE('0', 8)+ RTRIM(@V_CONTREGD), 8), @C_ARQ_D400, @P_NRSEQARQMAG);
         SET @V_CONTREGD =  ISNULL(@V_CONTREGD,0) + 1;

      DECLARE C_REGD450 CURSOR FOR (SELECT ('|D450'+ '|' +
                                ISNULL(I.NRSEQITPROD, '')      + '|' +
                                ISNULL(PR.CDARVPROD, '')       + '|' +
                                '00' + '|' +/* cdigo de classificao */
                                ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),I.VRUNITITEM))), '.', ','),'0,00')+ '|' +
                                ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),I.QTITEMPROD))), '.', ','),'0,00')+ '|' +
                                ISNULL(PR.SGUNIDADE, '')+ '|' +
                                ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),I.VRTOTAITEM))), '.', ','),'0,00')+ '|' +
                                ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.VALOR_ENCARGO(NF.CDFILIAL, NF.NRLANCTONF, 'D', DESCNF.IDENCARGODOS)))), '.', ','), '')+ '|' + /* valor total do desconto */
                                ISNULL(NF.CDFISCOPERNF, '')+ '|' +
                                ISNULL(NF.CDSITUTRIBNF, '')+ '|' +
                                ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),NF.VRBASECALCNF))), '.', ','),'0,00')+ '|' +
                                ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),NF.VRALIQNF))), '.', ','),'0,00')+ '|' +
                                ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),NF.VRIMPOSTONF))), '.', ','),'0,00')+ '|' +
                                '0' + '|' +/* indicador da receita */
                                ''  + '|' +
                                ''  + '|' +
                                ''  + '|' +
                                ''  + '|'  ) AS ARQ_D450
                        FROM ITEMPRODUTO I, PRODUTO PR,
                             (SELECT E.CDENCARGO, E.IDENCARGODOS
                              FROM RELACENCARGO E
                              WHERE E.IDENCARGODOS LIKE '%DESC%') DESCNF,

                             (SELECT I.CDFILIAL, I.NRLANCTONF, I.CDFISCOPERNF, I.CDSITUTRIBNF,
                                     I.VRBASECALCNF, I.VRALIQNF, I.VRIMPOSTONF
                              FROM MAPAAPURAC M, IMPOSTONF I
                              WHERE I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU            AND
                                    I.CDIMPOSTO       = @P_CDIMPOSTO              AND
                                    @C_ARQ20_CDMODDOCFISC    IN ('21','22')       AND
                                    @C_ARQ20_CDFILIAL        = I.CDFILIAL         AND
                                    @C_ARQ20_NRLANCTONF      = I.NRLANCTONF       AND
                                    ISNULL(I.IDIMPOSTONF, '1') <> '3'             AND
                                    ((ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') = '1') OR (ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') = '5'))) NF
                        WHERE I.CDFILIAL      = NF.CDFILIAL        AND
                              I.NRLANCTONF    = NF.NRLANCTONF      AND
                              I.CDPRODUTO     = PR.CDPRODUTO)
      OPEN C_REGD450;
      FETCH NEXT FROM C_REGD450 INTO @C_ARQ_D450;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('26'+RIGHT(REPLICATE('0', 8)+ RTRIM(@V_CONTREGD), 8), @C_ARQ_D450, @P_NRSEQARQMAG);
         SET @V_CONTREGD =  ISNULL(@V_CONTREGD,0) + 1;

         FETCH NEXT FROM C_REGD450 INTO @C_ARQ_D450;

      END;
      CLOSE C_REGD450;
      DEALLOCATE C_REGD450;

      DECLARE C_REGD460 CURSOR FOR (SELECT ('|D460'                                                                          + '|' +
                                ISNULL(N.CDSITUTRIBNF, '')                                                                   + '|' +
                                ISNULL(N.CDFISCOPERNF, '')                                                                   + '|' +
                                ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRCONTABILNF))), '.', ','), '')    + '|' +
                                ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRBASECALCNF))), '.', ','), '')    + '|' +
                                ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,N.VRALIQNF)), '.', ','), '')                           + '|' +
                                ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRIMPOSTONF))), '.', ','), '')     + '|'  ) AS ARQ_D460
                        FROM IMPOSTO P,
                             (SELECT I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBNF, I.CDFISCOPERNF,
                                     I.VRALIQNF, I.CDIMPOSTO,
                                     SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                     SUM(CASE I.CDFISCALNF WHEN '1' THEN I.VRBASECALCNF ELSE 0 END) AS VRBASECALCNF,
                                     SUM(CASE I.CDFISCALNF WHEN '1' THEN I.VRIMPOSTONF  ELSE 0 END) AS VRIMPOSTONF,
                                     SUM(CASE I.CDFISCALNF WHEN '3' THEN I.VRCONTABILNF ELSE 0 END) AS VROUTRCRED,
                                     SUM(CASE I.CDFISCALNF WHEN '2' THEN I.VRCONTABILNF ELSE 0 END) AS VRISENTRIB
                              FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I
                              WHERE M.CDEMPRESA              = @P_CDEMPRESA                          AND
                                    M.CDINSCESTA             = @P_CDINSCESTA                         AND
                                    M.DTINIPERIODO           = @P_DTINICIAL                          AND
                                    M.DTFIMPERIODO           = @P_DTFINAL                            AND
                                    M.CDIMPOSTO              = @P_CDIMPOSTO                          AND
                                    I.NRSEQUMAPAPU           = M.NRSEQUMAPAPU                        AND
                                    I.CDIMPOSTO              = @P_CDIMPOSTO                          AND
                                    ISNULL(I.IDIMPOSTONF,'1')<>'3'                                   AND
                                    N.CDFILIAL        = I.CDFILIAL                                   AND
                                    N.NRLANCTONF      = I.NRLANCTONF                                 AND
                                    ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))                       AND
                                    N.IDENTRSAIDOP    = 'S'                                          AND
                                    ((N.CDMODDOCFISC = '21') OR (N.CDMODDOCFISC = '22'))             AND
                                    ((ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') = '1') OR (ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') = '5'))
                              GROUP BY I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBNF, I.CDFISCOPERNF,
                                       I.VRALIQNF, I.CDIMPOSTO) N
                        WHERE N.CDIMPOSTO = P.CDIMPOSTO ) 

      OPEN C_REGD460;
      FETCH NEXT FROM C_REGD460 INTO @C_ARQ_D460;

      WHILE (@@FETCH_STATUS = 0) BEGIN

        INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('26'+RIGHT(REPLICATE('0', 8)+ RTRIM(@V_CONTREGD), 8), @C_ARQ_D460, @P_NRSEQARQMAG);
         SET @V_CONTREGD =  ISNULL(@V_CONTREGD,0) + 1;

         FETCH NEXT FROM C_REGD460 INTO @C_ARQ_D460;

      END;
      CLOSE C_REGD460;
      DEALLOCATE C_REGD460;

      FETCH NEXT FROM C_REGD400 INTO @C_ARQ_D400, @C400_CDFILIAL, @C400_NRLANCTONF, @C400_CDMODDOCFISC
  
   END;
   CLOSE C_REGD400;
   DEALLOCATE C_REGD400;

   /* ABERTURA DO REGISTRO D */
   IF @V_CONTREGD <> 0 BEGIN
      SET @V_MOVIMENT = 0;
   END
   ELSE BEGIN
      SET @V_MOVIMENT = 1;
   END;

   SET @V_CONTREGD = ISNULL(@V_CONTREGD,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('24'+RIGHT(REPLICATE('0', 8)+ RTRIM(@V_CONTREGD), 8), '|D001'+ '|' + CONVERT(VARCHAR, @V_MOVIMENT) + '|' , @P_NRSEQARQMAG);

   /* ENCERRAMENTO DO BLOCO E */
   SET @V_CONTREGD = ISNULL(@V_CONTREGD,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('27'+RIGHT(REPLICATE('0', 8)+ RTRIM(@V_CONTREGD), 8), '|D990'+ '|' + CONVERT(VARCHAR, @V_CONTREGD) + '|', @P_NRSEQARQMAG);

   SET @P_RETURN = @V_CONTREGD;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'ARQDIGITAL_BLOCOD','5.05.008';
GO

